#if !defined(SHRT_MAX)
#include <ctype.h>
#include <string.h>
#include <limits.h>
#endif

//	Define the types that "should" have been defined in Win16
//

#if !defined(_WIN32)
#define INT int
#define CONST const
#define STATIC static
#define EXTERN extern
#define BYTE byte
#define CHAR char
typedef WORD __far* LPWORD;
typedef LPSTR __far* LPLPSTR;
#else
typedef WORD * LPWORD;
typedef LPSTR * LPLPSTR;
#endif
typedef WNDPROC *PWNDPROC;


//	Helper macros
//

#define NUM_ELEMENTS(array)	(sizeof(array) / sizeof(array[0]))
#define STR_LEN(string)		(NUM_ELEMENTS(string) - 1)

#if defined(_DEBUG)
EXTERN INT nTraceLevel;
#define TRACEX(nLevel, nParams)			if (nTraceLevel >= nLevel) TRACE nParams
//#define AFX_DUMPX(nLevel, Variable)		if (nTraceLevel >= nLevel) AFX_DUMP1(#Variable " = ", Variable)
#define AFX_DUMPX(nLevel, Variable)		if (nTraceLevel >= nLevel) afxDump << Variable << "\n"
#else
#define TRACEX(nLevel, nParams)
#define AFX_DUMPX(nLevel, nParams)
#endif

//	Wrapper macros
//

#define IsSpace isspace
#define StrCmp	_fstrcmp
#define ToUpper toupper


//	Wrapper inlines
//

inline int StrNCmpI (LPCSTR str1, LPCSTR str2, INT nLen)
{
	return (_fstrnicmp(str1, str2, nLen));
}

inline void ZeroMem (LPVOID lpData, INT nLen)
{
	_fmemset(lpData, 0, nLen);
}

inline BOOL IsKeyPressed (INT nKey)
{
	return (::GetKeyState(nKey) < 0);
}

inline BOOL IsKeyToggled (INT nKey)
{
	return ((::GetKeyState(nKey) & 0x1) == 0x1);
}

inline BOOL IsAltPressed (void)		{ return (IsKeyPressed(VK_MENU)); }
inline BOOL IsShiftPressed (void)	{ return (IsKeyPressed(VK_SHIFT)); }
inline BOOL IsControlPressed (void)	{ return (IsKeyPressed(VK_CONTROL)); }

//	String extension
//
class CStringx : public CString
{
public:
// Constructors
	CStringx();
	CStringx(const CString& stringSrc);
	CStringx(char ch, int nRepeat = 1);
	CStringx(const char* psz);
	CStringx(const char* pch, int nLength);
	//	operations
public:
	INT FirstNonblank (void);
	INT LastNonblank (void);
	CStringx TrimLeading (void);
	CStringx TrimTrailing (void);
	CStringx Trim (void);
	INT FindAt (INT nPos, CHAR ch);
	INT FindAt (INT nPos, CONST CStringx& chars);
public:
	// overloaded assignment
	const CStringx& operator=(const CString& stringSrc);
	const CStringx& operator=(const CStringx& stringSrc);
	const CStringx& operator=(char ch);
	const CStringx& operator=(const char* psz);
	operator CString (void) { return (*(CString*)this); }
};

#if FALSE
class CStringxArray : public CObjArray
{
public:
	CStringxArray();
	void ~CStringxArray();
	CStringx operator[] (INT i) { 
}
#endif

//	Miscellaneous functions
//
void TokenizeText (CStringArray& tokens, CONST CStringx& text, CONST CStringx& delims);
HWND GetMainHwnd (void);
CStringx GetTempPath (void);
HTASK GetTaskHandle (LPCSTR lpszName);

