//	Copyleft 1993-1995 Tom O'Hara		Cword: A crossword puzzle assistant
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

// cword.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
//#include "common.h"
#include "cword.h"
#include "mainfrm.h"
#include "lookup.h"
#include "gridview.h"
#include "cworddoc.h"
#include "about.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif

// Constants
//
//CONST CHAR szCWORD_REG_KEY[] = "Nonesuch\\CWord";
CONST CHAR szCWORD_REG_KEY[] = "Nonesuch";

//  Globals
//
CCwordApp NEAR theApp;					// The one and only CCwordApp object



/////////////////////////////////////////////////////////////////////////////
// CCwordApp

BEGIN_MESSAGE_MAP(CCwordApp, CWinApp)
    //{{AFX_MSG_MAP(CCwordApp)
    ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
        // NOTE - the ClassWizard will add and remove mapping macros here.
        //    DO NOT EDIT what you see in these blocks of generated code !
    //}}AFX_MSG_MAP
    // Standard file based document commands
    ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
    ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
    // Standard print setup command
    ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCwordApp construction

CCwordApp::CCwordApp()
    :   hOldCursor (NULL)
{
	INIT_DEBUGGING_("CWord.ini");
	DEBUG_OUT(TL_VERBOSE, ("CCwordApp::CCwordApp()\n"));
}


/////////////////////////////////////////////////////////////////////////////
// CCwordApp initialization

BOOL CCwordApp::InitInstance()
{
	DEBUG_OUT(TL_VERBOSE, ("CCwordApp::InitInstance()\n"));
	InitCommon(m_hInstance, NULL, "cword");

	// Initialize OLE 2.0 libraries
	BOOL bUseOLE = GetDebugOption("UseOLE", TRUE);
	if (bUseOLE && !AfxOleInit())
	{
		AfxMessageBox("OLE initialization failed");
		return FALSE;
	}

#if TRUE
	//Enable3dControls();
	SetDialogBkColor();
#endif

    // Standard initialization
    // If you are not using these features and wish to reduce the size
    //  of your final executable, you should remove from the following
    //  the specific initialization routines you do not need.

	BOOL bUseRegistry = GetDebugOption("UseRegistry", TRUE);
	if (bUseRegistry) {
		SetRegistryKey(szCWORD_REG_KEY);
	}
    LoadStdProfileSettings();  // Load standard INI file options (including MRU)

    // Register the application's document templates.  Document templates
    //  serve as the connection between documents, frame windows and views.

    AddDocTemplate(new CSingleDocTemplate(IDR_MAINFRAME,
            RUNTIME_CLASS(CCwordDoc),
            RUNTIME_CLASS(CMainFrame),     // main SDI frame window
            RUNTIME_CLASS(CGridView)));

	//ASSERT(AfxGetMainWnd());
	//InitCommon(m_hInstance, NULL, "cword");
	//INIT_DEBUGGING_("cword.ini");
	//DEBUG_OUT(TL_VERBOSE, ("CCwordApp::InitInstance()\n"));

	// Initialize the static part of the lookup class (eg, MediaView access)
	CLookup::InitLookup(AfxGetMainWnd());

    // create a new (empty) document
    OnFileNew();

	// Set the application window for anchoring error dialogs
	RegisterAppWindow(m_hInstance, m_pMainWnd->m_hWnd);

    ParseCmdLine(m_lpCmdLine);
    if (m_lpCmdLine[0] != '\0') {
        // TODO: add command line processing here
        }

    //  Cword-specific initializations
    LoadCwordProfileSettings();

    return TRUE;
}

BOOL CCwordApp::ExitInstance (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CCwordApp::ExitInstance()\n"));

	// Cleanup the static part of the lookup class (eg, MediaView access)
	CLookup::CleanupLookup();

	// Invoke the base class cleanup (eg, flush INI settings)
	CWinApp::ExitInstance();

	END_DEBUGGING();

	return (TRUE);
}


// App command to run the dialog
void CCwordApp::OnAppAbout()
{
    CAboutDlg aboutDlg;
    aboutDlg.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// CCwordApp commands

void CCwordApp::SetCursor (UINT nCursor)
{
    if (!hOldCursor) {
        hOldCursor = ::SetCursor(LoadCursor(nCursor));
        }
}

void CCwordApp::RestoreCursor (void)
{
    if (hOldCursor) {
        ::SetCursor(hOldCursor);
        hOldCursor = NULL;
        }
}

void CCwordApp::LoadCwordProfileSettings (void)
{
}
