// cworddoc.cpp : implementation of the CCwordDoc class
//

#include "stdafx.h"
//#include "common.h"
#include "cword.h"
#include "lookup.h"
#include "gridview.h"
#include "cworddoc.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCwordDoc

IMPLEMENT_DYNCREATE(CCwordDoc, CDocument)

#define new DEBUG_NEW

BEGIN_MESSAGE_MAP(CCwordDoc, CDocument)
    //{{AFX_MSG_MAP(CCwordDoc)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE, OnUpdateFileSave)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE_AS, OnUpdateFileSaveAs)
	ON_UPDATE_COMMAND_UI(ID_FILE_PRINT, OnUpdateFilePrint)
	ON_UPDATE_COMMAND_UI(ID_FILE_PRINT_PREVIEW, OnUpdateFilePrintPreview)
	ON_UPDATE_COMMAND_UI(ID_FILE_PRINT_SETUP, OnUpdateFilePrintSetup)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCwordDoc construction/destruction

CCwordDoc::CCwordDoc()
{
    // TODO: add one-time construction code here
//    m_pDocGrid = NULL;
}

CCwordDoc::~CCwordDoc()
{
}

BOOL CCwordDoc::OnNewDocument()
{
    if (!CDocument::OnNewDocument())
        return FALSE;
    // TODO: add reinitialization code here
    // (SDI documents will reuse this document)
    return TRUE;
}


CGridView* CCwordDoc::FirstView (VOID)
{
	DEBUG_OUTF(TL_VERBOSE, ("CCwordDoc::FirstView()\n"));

	POSITION posView = GetFirstViewPosition();
	return (NextView(posView));
}


CGridView* CCwordDoc::NextView (POSITION& posView)
{
	DEBUG_OUTF(TL_VERBOSE, ("CCwordDoc::NextView()\n"));
	CGridView* pView = NULL;

	if (posView != NULL) {
		pView = (CGridView*)GetNextView(posView);
		}

	return (pView);
}


/////////////////////////////////////////////////////////////////////////////
// CCwordDoc serialization

void CCwordDoc::Serialize(CArchive& ar)
{
    if (ar.IsStoring()) {
        // TODO: add storing code here
    }
    else {
#if FALSE
      	CGridView* pView = FirstView();
		if (pView != NULL) {
			CFile* pFile = ar.GetFile();
			ASSERT(pFile);
			if (pFile) {
				CString sFile = pFile->GetFilePath();
				pView->ReadPuzzle(sFile);
				}
			}
#endif
		ASSERT_ERROR();		// serialization is bypassed
		}
}


/////////////////////////////////////////////////////////////////////////////
// CCwordDoc diagnostics

#ifdef _DEBUG
void CCwordDoc::AssertValid() const
{
    CDocument::AssertValid();
}

void CCwordDoc::Dump(CDumpContext& dc) const
{
    CDocument::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCwordDoc commands

void CCwordDoc::OnFileOpen() 
{
	DEBUG_OUT(TL_VERBOSE, ("CCwordDoc::OnFileOpen()\n"));
	//AfxGetApp()->OnFileOpen();
}


BOOL CCwordDoc::OnOpenDocument(LPCTSTR lpszPathName)
{
	DEBUG_OUT(TL_VERBOSE, ("CCwordDoc::OnOpenDocument(%s)\n", F(lpszPathName)));
	BOOL bOK = FALSE;

	CGridView* pView = FirstView();
	ASSERT_VALID(pView);
	if (pView){
		bOK = pView->ReadPuzzle(lpszPathName);
		}

	return (bOK);
}

void CCwordDoc::OnUpdateFileSave(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(TRUE);
}

void CCwordDoc::OnUpdateFileSaveAs(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(TRUE);
}

void CCwordDoc::OnUpdateFilePrint(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(FALSE);
}

void CCwordDoc::OnUpdateFilePrintPreview(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(FALSE);
}

void CCwordDoc::OnUpdateFilePrintSetup(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(FALSE);
}

void CCwordDoc::OnFileSave() 
{
	DEBUG_OUT(TL_VERBOSE, ("CCwordDoc::OnFileSave()\n"));
	OnSaveDocument(GetPathName());
}


BOOL CCwordDoc::OnSaveDocument(LPCTSTR lpszPathName)
{
	DEBUG_OUT(TL_VERBOSE, ("CCwordDoc::OnSaveDocument(%s)\n", F(lpszPathName)));
	BOOL bOK = FALSE;

	CWaitCursor();
	CGridView* pView = FirstView();
	ASSERT_VALID(pView);
	if (pView){
		bOK = pView->WritePuzzle(lpszPathName);
		}
	SetModifiedFlag(FALSE);

	return (bOK);
}
