//	Copyleft 1993-1995 Tom O'Hara		A simple library of common stuff
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

#if !defined(_COMMON_INL)
#define _COMMON_INL

#if !defined(_COMMON_H)
#include "common.h"
#endif


INLINE VOID MyAfxSetApp (CWinApp* pApp)
{
	ASSERT_VALID(pApp);
	if (pApp && pApp->IsKindOf(RUNTIME_CLASS(CWinApp))) {
		pWinApp = pApp;
		}
}

INLINE CWinApp* MyAfxGetApp (VOID)
{
	return (pWinApp ? pWinApp : AfxGetApp());
	ASSERT_VALID(pWinApp);
}


inline VOID SkipSpaces (CONST CString& text, INT& i)
{
    ASSERT(i <= text.GetLength());
    while((i < text.GetLength()) 
    	  && IsSpace(text[i])) {
        i++;
        }
}

INLINE CString SkipSpaces (CONST CString& text)
{
	INT i = 0;
	SkipSpaces(text, i);
	CString sRest = text.Mid(i);
	return (sRest);
}

inline BOOL IsDelim (CHAR ch)
{
    CONST CString delims = "/-";
    BOOL bDelim = (delims.Find(ch) != -1);
    
    return (bDelim);
}

inline CString String (LONG lValue)
{
    CHAR szText[20];
    sprintf(szText, "%ld", lValue);
    return (szText);
}

inline CString String (INT nValue)
{
    CHAR szText[20];
    sprintf(szText, "%d", nValue);
    return (szText);
}

inline CString LongToString (LONG lValue)
{
    TRACE("LongToString is obsolete; use String instead\n");
    return (String(lValue));
}

inline CString IntToString (INT nValue)
{
    TRACE("IntToString is obsolete; use String instead\n");
    return (String(nValue));
}

inline CString DoubleToString (DOUBLE dValue)
{
    CHAR szText[20];
    sprintf(szText, "%g", dValue);
    return (szText);
}

inline CString FloatToString (FLOAT flValue)
{
    CHAR szText[20];
    sprintf(szText, "%g", flValue);
    return (szText);
}

inline BOOL ValidIndex (INT nPos, CONST CObArray& array)
{
    return ((nPos >=0) && (nPos < array.GetSize()));
}

inline BOOL ValidIndex (INT nPos, CONST CStringArray& array)
{
    return ((nPos >=0) && (nPos < array.GetSize()));
}



INLINE INT Pos (PCSZ pszSource, CHAR cTarget)
{
    INT nPos = nINVALID_INDEX;

    PCSZ pszPos = strchr(pszSource, cTarget);
    if (pszPos) {
        nPos = pszPos - pszSource;
    	}

    return (nPos);
}


INLINE INT Pos (PCSZ pszSource, PCSZ pszTarget)
{
    INT nPos = nINVALID_INDEX;

    PCSZ pszPos = strstr(pszSource, pszTarget);
    if (pszPos) {
        nPos = pszPos - pszSource;
    	}

    return (nPos);
}


INLINE BOOL IsNumeric (CHAR c)        { return (isdigit(c)); }


INLINE BOOL IsNumeric  (PCSZ pszSource)
{
	BOOL bNumeric = *pszSource ? TRUE : FALSE;
    while (*pszSource) {
		if (!IsNumeric(*pszSource)) {
			bNumeric = FALSE;
			break;
			}
        pszSource++;
    	}

    return (bNumeric);
}


INLINE BOOL IsKeyToggled (int nKey, BOOL bAsync)
{
    INT nState = bAsync ? GetAsyncKeyState(nKey) : GetKeyState(nKey);
    BOOL bToggled = (nState & 0x1);
    return (bToggled);
}

INLINE BOOL IsCapsLockOn (BOOL bAsync = FALSE)
{
	return (IsKeyToggled(VK_CAPITAL, bAsync));
}

INLINE BOOL IsNumLockOn (BOOL bAsync = FALSE)
{
	return (IsKeyToggled(VK_NUMLOCK, bAsync));
}

INLINE BOOL IsCommandSwitchDelim (CHAR ch)
{
	return (IsDelim(ch));
}

INLINE INT StringToInt (CONST CString& text)
{
	INT nPos = 0;
	INT nNum = StringToInt(text, nPos);
	return (nNum);
}

#endif  // !defined(_COMMON_INL)
