//	Copyleft 1993-1995 Tom O'Hara		A simple library of common stuff
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

#if !defined(_EDITX_H)
#define _EDITX_H

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

//-----------------------------------------------------------------------------

//	typedef struct tagNMHDR {
//		HWND hwndFrom;
//		UINT idFrom;
//		UINT code;
//		} NMHDR;

// HACK HACK
CONST CHAR szNMHDREX[] = "NMHDREX";

typedef struct tagNMHDREX {
	NMHDR nmhdr;
	WPARAM wParam;
	LPARAM lParam;
	CHAR szSignature[8];
	} NMHDREX;

inline BOOL IsValidNMHDREX (NMHDREX* pNMHDREX)
{
	return (pNMHDREX && (StringCompare(pNMHDREX->szSignature, szNMHDREX) == 0));
}

//-----------------------------------------------------------------------------

class CEditx : public CEdit
{
//	DECLARE_DYNAMIC(CEditx)
	DECLARE_DYNCREATE(CEditx)
public:
	CEditx();
	BOOL Create (DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID);
	virtual ~CEditx ();
	virtual PWNDPROC GetSuperWndProcAddr (void);
	void AllocFont (void);
	void ReleaseFont (void);
	void CreateFont (INT nSize, CStringx facename);
	void CreateFontIndirect (const LOGFONT FAR* lpLogFont);
	CFont* GetFont (void) { return (m_pfont); };
	BOOL IsFontSet (void) { return (m_pfont != NULL); };
	virtual void ChangeFont (void);
	static void InvokeChangeFont (CWnd* pwnd);
	void NotifyOfKeystrokes (BOOL bNotify = TRUE)	{ m_bNotifyOfKeystrokes = bNotify; }
	void NotifyOfClicks (BOOL bNotify = TRUE)	{ m_bNotifyOfClicks = bNotify; }
private:
	CFont *m_pfont;
	BOOL m_bFontSet;
	BOOL m_bNotifyOfKeystrokes;
	BOOL m_bNotifyOfClicks;
protected:
	// Generated message map functions
	//{{AFX_MSG(CEditx)
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnClose();
	afx_msg void OnDestroy();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};



#endif	// !defined(_EDITX_H)
