// Copyleft 1993-1995 Tom O'Hara
// These files are distributed under the provisions of the GNU general copyright, as
// defined by the Free Software Federation. They may be freely distributed as long as
// this notice is included. 
//

#include "common.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

#define new DEBUG_NEW

#if defined(_WIN32)

HTASK GetTaskHandle (LPCSTR lpszName)
{
	UNREFERENCED_PARAMETER(lpszName);
#pragma message("GetTaskHandle always returns NULL under Win32")
	return (NULL);
}

#else

#include <toolhelp.h>
HTASK GetTaskHandle (LPCSTR lpszName)
{
	HTASK hTask = NULL;
#if _DEBUG_MODE
	TASKENTRY te;
	ZeroMem(&te, sizeof(te));
	te.dwSize = sizeof(te);
	
	for (BOOL bMore = ::TaskFirst(&te); (bMore); bMore = ::TaskNext(&te)) {
		if (!StrCmp(te.szModule, lpszName)) {
			hTask = te.hTask;
			break;
			}
		}
#endif	// _DEBUG
	return (hTask);
}
#endif	// _WIN32
