// gridview.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CGridView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

class CGridView : public CFormView
{
    DECLARE_DYNCREATE(CGridView)
protected:
    CGridView();            // protected constructor used by dynamic creation

// Form Data
public:
    //{{AFX_DATA(CGridView)
    enum { IDD = IDD_CWORD_PLUS };
    CButton m_suggestions;
    CEditx m_words;
    CEditx m_clue;
    CEditx m_def;
    CStringx m_szChar;
    CStringx m_szClue;
    CEditx m_cwordChar;
    //}}AFX_DATA

// Attributes
public:
    const INT NUM_ROWS;
    const INT NUM_COLS;
    CByteArray* m_pcRow;
    INT m_nCellHeight;
    INT m_nCellWidth;
    INT m_nCol;
    INT m_nRow;
    CLookup lu;

// Operations
public:
    BOOL ConvertPoint (CPoint& point, INT& nRow, INT& nCol);
    CRect GetCellRect (INT nRow, INT nCol);
    CRect GetCurrentCellRect (void);
    void InvalidateCell (void);
    void ChangeCell (INT nRow, INT nCol);

    void GetHorizontalPattern (void);
    void GetVerticalPattern (void);
    void ShowSuggestions (void);

// Implementation
protected:
    virtual ~CGridView();
    virtual void OnDraw (CDC* pDC);
    virtual void OnInitialUpdate();
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    // Generated message map functions
    //{{AFX_MSG(CGridView)
    afx_msg void OnChangeCwordChar();
    afx_msg void OnSuggestHorizontal();
    afx_msg void OnSuggestVertical();
    afx_msg void OnHelpSynonyms();
    afx_msg void OnHelpReferences();
    afx_msg void OnHelpDefinition();
    afx_msg void OnMiscChangefont();
    afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
    afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg VOID OnNotifyKeydown (NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
