#if !defined(_XWORD_H)
#define _XWORD_H

//	Types for crossword analysis
//	
typedef enum {EDGE_LEFT, EDGE_TOP, EDGE_BOTTOM, EDGE_RIGHT} EDGE_TYPE;
//typedef unsigned char BYTE;

#define CPointArray CArray<CPoint, CPoint&>
#define CIntArray CArray<INT, INT>


class CCrossWordImage : public CObject
{
	DECLARE_DYNAMIC(CCrossWordImage);
public:
	CCrossWordImage (VOID);
	CCrossWordImage (LPVOID pDIB, LPBYTE pBitmapData, DWORD dwBytesPerRow, DWORD dwNumRows);
	VOID Init (LPVOID pDIB, LPBYTE pBitmapData, DWORD dwBytesPerRow, DWORD dwNumRows);
	~CCrossWordImage (VOID);
//	Operations
	VOID Analyze (VOID);
	VOID WriteCrosswordDescriptor (VOID);
	VOID SetFileName (CONST CString& sName)	{ m_sFileName = sName; }
//	CPointArray& GetLinePoints (VOID)		{ return (m_linepoints); }
//	Internal operatons
	BYTE GetByte (INT nRefRow, INT nRefCol, EDGE_TYPE eEdgeType, INT nOffset);
	BOOL IsOnLine (INT i, INT j, EDGE_TYPE eEdgeType);
	VOID DetermineRowColBounds (INT nDepth, EDGE_TYPE eEdge,
								INT& nStartRow, INT& nEndRow, INT& nStartCol, INT& nEndCol);
	INT GetMode (PINT pnCounts);
	VOID GetMinMaxAndDelta (CPointArray& endpoints, EDGE_TYPE eEdge, INT& nMin, INT& nMax, INT& nDelta);
	VOID FindCandidateEndpoints (CPointArray& points, EDGE_TYPE eEdge, INT nDepth);
	VOID ReconcilePointArrays (VOID);
	VOID ConvertPixelToCell (DWORD i,  DWORD j, DWORD& dwGridRow, DWORD& dwGridCol);
	VOID FindCandidateBlackSquares (VOID);
//	Implementation
public:
	CByteArray* m_pMatrix;
	DWORD m_dwNumRows;
	DWORD m_dwNumCols;
	DWORD m_dwMaxDimen;
	//CPointArray m_linepoints;
	CPointArray m_pointsLeft;
	CPointArray m_pointsTop;
	CPointArray m_pointsBottom;
	CPointArray m_pointsRight;
	INT m_nNumHorzPoints;
	INT m_nNumVertPoints;
	CSize m_sizeCell;
	CSize m_sizeAdjustedCell;
	CPointArray m_cellsBlackened;
	CString m_sFileName;
};


//	Miscellaneous functions
//
VOID DumpPointArray (INT nTraceLevel, PCSZ pszPrefix, CPointArray& points, EDGE_TYPE eEdge);
VOID DumpPointArray (INT nTraceLevel, PCSZ pszPrefix, CPointArray& points);
VOID ShowCrosswordGrid (CDC* pDC, CRect& rcDest);

#endif	// !defined(_XWORD_H)
