//	Copyleft 1993-1995 Tom O'Hara		A simple library of common stuff
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

#if !defined(_COMMONXX_INL)
#define _COMMONXX_INL


//	First, stuff just for C++.
//

#if defined(__cplusplus)

INLINE VOID AddPathDelim (PSZ pszDir)
{
	AddPathDelim(pszDir, -1);
}

#endif	// defined(__cplusplus)


//	The remaining must be valid for normal C, so INLINE must resolve to '__inline'
//	instead of 'inline' and CONST to 'static const' instead of 'const'. In addition,
//	there must be no overloading and no reference parameters.
//

//  Accessors and maniuplators for global variables
//

INLINE BOOL IsMessageLoopPaused (VOID)      { return (_bPauseMsgLoop); }
INLINE VOID PauseMessageLoop (BOOL bPause)  { _bPauseMsgLoop = bPause; }

INLINE BOOL IsAppActive (VOID)          { return (_bAppActive); }
INLINE VOID SetAppActive (BOOL bActive) { _bAppActive = bActive; }
INLINE HWND GetAppWnd (VOID)      { return (_hAppWnd); }
INLINE VOID SetAppWnd (HWND hWnd) { _hAppWnd = hWnd; }
INLINE PCSZ GetAppName (VOID)     { return (_szAppName); }
INLINE VOID SetAppName (PCSZ pszName) \
                { ASSERT(pszName);
                  StringCopy(_szAppName, pszName); }


INLINE INT GetNumClients (VOID)         { return (_nNumClients); }
INLINE VOID SetNumClients (INT  nNum)   { _nNumClients = nNum; }

INLINE BOOL IsClientAppActive (INT i)
{ 
    ASSERT(i < nMAX_CLIENTS);
    return (_aci[i].bAppActive);
}

INLINE VOID SetClientAppActive (INT i, BOOL bActive)
{
    ASSERT(i < nMAX_CLIENTS);
    _aci[i].bAppActive = bActive;
}

INLINE HWND GetClientAppWnd (INT i)
{
    ASSERT(i < nMAX_CLIENTS);
    return (_aci[i].hClientAppWnd);
}

INLINE VOID SetClientAppWnd (INT i, HWND hWnd)
{
    ASSERT(i < nMAX_CLIENTS);
    _aci[i].hClientAppWnd = hWnd;
}

INLINE HINSTANCE GetClientAppInst (INT i)
{
    ASSERT(i < nMAX_CLIENTS);
    return (_aci[i].hClientAppInst);
}

INLINE VOID SetClientAppInst (INT i, HINSTANCE hInst)
{
    ASSERT(i < nMAX_CLIENTS);
    _aci[i].hClientAppInst = hInst;
}

INLINE HTASK GetClientAppTask (INT i)
{
    ASSERT(i < nMAX_CLIENTS);
    return (_aci[i].hClientAppTask);
}

INLINE VOID SetClientAppTask (INT i, HTASK hTask)
{
    ASSERT(i < nMAX_CLIENTS);
    _aci[i].hClientAppTask = hTask;
}

INLINE PCSZ GetClientAppName (INT i)
{
    ASSERT(i < nMAX_CLIENTS);
    return (_aci[i].szClientAppName);
}

INLINE VOID SetClientAppName (INT i, PCSZ pszName)
{
    ASSERT(i < nMAX_CLIENTS);
    StringCopy(_aci[i].szClientAppName, pszName);
}

#endif // !defined(_COMMONXX_INL)
