//	Copyleft 1993-1995 Tom O'Hara		A simple library of common stuff
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

// NonStdAfx.h : include file for standard MFC include files, albeit in
//  in nonstandard way.
//

#if !defined(_NON_STD_AFX_H)
#define _NON_STD_AFX_H


#if defined(QUICK_WIN)
#	include <afx.h>					// Old MFC main header
#	include <afxcoll.h>				// Old MFC collection classes header
#endif


#if !defined(QUICK_WIN)

#	define VC_EXTRALEAN				// Exclude rarely-used stuff from Windows headers

#	include <afxwin.h>				// MFC core and standard components
#	include <afxext.h>				// MFC extensions

#	if !defined(_AFX_NO_OLE_SUPPORT)
#		include <afxole.h>			// MFC OLE classes
#		include <afxodlgs.h>		// MFC OLE dialog classes
#		include <afxdisp.h>			// MFC OLE automation classes
#	endif // !defined(_AFX_NO_OLE_SUPPORT)


#	if !defined(_AFX_NO_DB_SUPPORT)
#		include <afxdb.h>			// MFC ODBC database classes
#	endif // !defined(_AFX_NO_DB_SUPPORT)

#	if !defined(_AFX_NO_DAO_SUPPORT)
#		include <afxdao.h>			// MFC DAO database classes
#	endif // !defined(_AFX_NO_DAO_SUPPORT)

#	if !defined(_AFX_NO_AFXCMN_SUPPORT)
#		include <afxcmn.h>			// MFC support for Windows 95 Common Controls
#	endif // !defined(_AFX_NO_AFXCMN_SUPPORT)

#	include <afxole.h>				// MFC OLE classes

#if !defined(ALL_WARNINGS)
#	pragma warning(disable: 4127)   // constant expression for TRACE/ASSERT
#endif
#	include <afxtempl.h>			// MFC template classes

#	include <afxmt.h>				// MFC support for multithreading


// Turn the warnings back on which were disabled in the MFC headers
//
// NOTE: Keep this in synch with the warnings disabled in AFX.H
//
#if !defined(ALL_WARNINGS)

// warnings generated with common MFC/Windows code
#pragma warning(default: 4127)  // constant expression for TRACE/ASSERT
#pragma warning(default: 4134)  // message map member fxn casts
#pragma warning(default: 4201)  // nameless unions are part of C++
#pragma warning(default: 4511)  // private copy constructors are good to have
#pragma warning(default: 4512)  // private operator= are good to have
#pragma warning(default: 4514)  // unreferenced inlines are common
#pragma warning(default: 4710)  // private constructors are disallowed
#pragma warning(default: 4705)  // statement has no effect in optimized code

// warnings caused by normal optimizations
#if !defined(_DEBUG)
#pragma warning(default: 4701)  // local variable *may* be used without init
#pragma warning(default: 4702)  // unreachable code caused by optimizations
#pragma warning(default: 4791)  // loss of debugging info in retail version
#endif

// warnings specific to _AFXDLL version
#if defined(_AFXDLL)
#pragma warning(default: 4204)  // non-constant aggregate initializer
#endif

#if defined(_AFXDLL)
#pragma warning(default: 4275)  // deriving exported class from non-exported
#pragma warning(default: 4251)  // using non-exported as public in exported
#endif

#pragma warning(default: 4114)  // same type qualifier used more than once

// Ok, now punt on a few of these
#pragma warning(disable: 4134)  // conversion between pointers to members of same class
#pragma warning(disable: 4511)  // copy constructor could not be generated
#pragma warning(disable: 4512)  // assignment operator could not be generated

#endif // !defined(ALL_WARNINGS)


#endif	// !defined(QUICK_WIN)


#endif // !defined(_NON_STD_AFX_H)
