//	Copyleft 1993-1996 Tom O'Hara		TrlLookup source
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

#if !defined(_PHRASE_H)
#define _PHRASE_H

#ifdef __cplusplus
extern "C" {
#endif

INT 	GetKey 			(PSZ pszKey, INT nMaxChars, PCSZ pszPhrase, BOOL bStrict);
INT 	PhraseCompare 	(PCSZ pszPhrase1, PCSZ pszPhrase2, BOOL bStrict);

CONST CHAR szIGNORE_INDEXING[] = "-, .";
CONST CHAR szIGNORE_SEARCHING[] = "-, .{";


inline BOOL IgnoreChar (CHAR c, BOOL bStrict)
{
	return ((c == cDASH) || (c == cCOMMA) || (c == cSPACE) || (c == cPERIOD)
			|| (!bStrict && (c == cSINGLE_QUOTE)));
	// || (c == '{') || (c == '}));	--don't include since this would affect search
	// || (c == '\'')); --don't include since DICT1 requires distinction
}

inline BOOL EndOfPhrase (PCSZ pszPhrase)
{
//	return ((*pszPhrase == '\0') || (*pszPhrase == '{'));
	return (*pszPhrase == cNULL);
}

inline INT PhraseEQ (PCSZ pszPhrase1, PCSZ pszPhrase2, BOOL bStrict)
{
	return (PhraseCompare(pszPhrase1, pszPhrase2, bStrict) == 0);
}

inline INT PhraseGT (PCSZ pszPhrase1, PCSZ pszPhrase2, BOOL bStrict)
{
	return (PhraseCompare(pszPhrase1, pszPhrase2, bStrict) > 0);
}

#ifdef __cplusplus
}
#endif

#endif	// !defined(_PHRASE_H)
