/*

  wnglobals.h

*/

/* $Id: WNGLOBAL.H,v 1.1 1996/05/15 09:18:00 anonymous Exp $ */

#ifndef _WNGLOBALS_
#define _WNGLOBALS_

#include <stdio.h>

extern char *wnrelease;		/* WordNet release number */
extern char *lexfiles[];	/* names of lexicographers' files */
extern char **wn_filenames;	/* names of files in database being used */
extern int datastart;		/* byte offset of start of data in data.pos */
extern char *ptrtyp[];		/* pointer characters */
extern char *partnames[];	/* POS strings */
extern char partchars[];	/* single chars for each POS */
extern char *adjclass[];	/* adjective class strings */
extern char *frametext[];	/* text of verb frames */

/* Global variables */

extern int SenseCount;		/* number of senses word has */
extern int OutSenseCount;	/* number of senses search found */
extern int fnflag;		/* if set, print lex filename after sense */
extern int dflag;		/* if set, print definitional glosses */
extern int saflag;		/* if set, print SEE ALSO pointers */
extern int frflag;		/* if set, print verb frames after synset */
extern int abortsearch;		/* if set, stop search algorithm */
/* database file pointers */
extern int OpenDB;		/* if non-zero, database file are open */
extern FILE *datafps[NUMPARTS + 1], *indexfps[NUMPARTS + 1],
*sensefp, *cousinfp, *cousinexcfp;

#endif /* _WNGLOBALS_ */

/*
  Revision log:

  $Log: WNGLOBAL.H,v $
 * Revision 1.1  1996/05/15  09:18:00  anonymous
 * Initial revision
 *
 * Revision 1.21  1995/02/07  16:12:08  wn
 * added OpenDB
 *
 * Revision 1.20  1995/01/20  20:10:28  wn
 * added stuff to help find size of license and dbfiles
 *
 * Revision 1.19  1995/01/06  21:24:23  wn
 * added abortsearch flag
 *
 * Revision 1.18  1994/11/22  15:44:11  wn
 * added cousinexcfp
 *
 * Revision 1.17  1994/11/18  18:55:45  wn
 * added cousinfp
 *
 * Revision 1.16  1994/10/07  14:41:09  wn
 * cleanup, added filenames
 *
 * Revision 1.15  1993/06/09  14:57:27  wn
 * *** empty log message ***
 *
 * Revision 1.14  93/06/09  14:52:24  wn
 * added file pointers
 * 
 * Revision 1.13  93/04/21  11:18:56  wn
 * no changes
 * 
 * Revision 1.12  93/03/11  16:37:07  wn
 * add #ifdefs to protect against multiple inclusions
 * 
 * Revision 1.11  92/11/17  14:52:09  wn
 * removed helptext
 * 
 * Revision 1.10  92/11/12  16:19:11  wn
 * cleanups for release 1.3 - merged change required for mac and next ports
 * 
 * Revision 1.9  92/10/15  13:16:35  wn
 * added helptext
 * 
 * Revision 1.8  92/09/09  13:27:16  wn
 * *** empty log message ***
 * 
 * Revision 1.7  92/03/26  14:46:06  wn
 * removed search_cmd
 * 
 * Revision 1.6  92/03/19  11:47:29  wn
 * added search_cmd
 * 
 * Revision 1.5  91/12/18  11:52:41  wn
 * no changes
 * 
 * Revision 1.4  91/12/13  15:21:45  wn
 * changed name from enums.h
 * removed isdef and freqcats.  added adjclass
 * 
 * Revision 1.3  91/12/10  16:24:09  wn
 * removed nfnames, vfnames, afnames static structures
 * 
 * Revision 1.2  91/12/04  10:38:27  wn
 * added partchars
 * 
 * Revision 1.1  91/09/25  15:39:14  wn
 * Initial revision
 * 
*/
