//	Copyleft 1993-1996 Tom O'Hara		Lookup source
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

// LookupOptions.h : header file
//

#if defined(HIDE_LOOKUP_DETAILS)
#define DLL_CLASS_EXPORT
#else
#define DLL_CLASS_EXPORT	__declspec(dllexport)
#endif
#if !defined(DLL_EXPORT)
#define DLL_EXPORT			__declspec(dllexport)
#endif


/////////////////////////////////////////////////////////////////////////////
// CBookshelfOptions dialog

class DLL_CLASS_EXPORT CBookshelfOptions : public CPropertyPage
{
	DECLARE_DYNCREATE(CBookshelfOptions)

// Construction
public:
	CBookshelfOptions();
	~CBookshelfOptions();

// Dialog Data
	//{{AFX_DATA(CBookshelfOptions)
	enum { IDD = IDD_PROPPAGE_BS_LOOKUP };
	CButton	m_btnBrowseDir;
	CString	m_sBookshelfDir;
	BOOL	m_bUseBookshelf;
	//}}AFX_DATA
	BOOL	m_bSettingsChanged;

// Operations
	VOID PrepareMisc (VOID);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBookshelfOptions)
	public:
	virtual void OnOK();
	virtual BOOL OnApply();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	BOOL ApplySettings (VOID);

	// Generated message map functions
	//{{AFX_MSG(CBookshelfOptions)
	afx_msg void OnChangeBookshelfDataDirectory();
	afx_msg void OnUseBookshelf();
	afx_msg void OnBrowse();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////
// CTrlOptions dialog

class DLL_CLASS_EXPORT CTrlOptions : public CPropertyPage
{
	DECLARE_DYNCREATE(CTrlOptions)

// Construction
public:
	CTrlOptions();
	~CTrlOptions();

// Dialog Data
	//{{AFX_DATA(CtrlOptions)
	enum { IDD = IDD_PROPPAGE_TRL_LOOKUP };
	CButton	m_btnBrowseDir;
	CString	m_sTrlDir;
	BOOL	m_bUseTrl;
	//}}AFX_DATA
	BOOL	m_bSettingsChanged;

// Operations
	VOID PrepareMisc (VOID);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTrlOptions)
	public:
	virtual BOOL OnApply();
	virtual void OnOK();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	VOID ApplySettings (VOID);

	// Generated message map functions
	//{{AFX_MSG(CTrlOptions)
	afx_msg void OnChangeTrlDataDirectory();
	afx_msg void OnBrowse();
	afx_msg void OnUseTrl();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////
// CWordNetOptions dialog

class DLL_CLASS_EXPORT CWordNetOptions : public CPropertyPage
{
	DECLARE_DYNCREATE(CWordNetOptions)

// Construction
public:
	CWordNetOptions();
	~CWordNetOptions();

// Dialog Data
	//{{AFX_DATA(CWordNetOptions)
	enum { IDD = IDD_PROPPAGE_WN_LOOKUP };
	CButton	m_btnBrowseDir;
	BOOL	m_bUseWordNet;
	CString	m_sWordNetDir;
	BOOL	m_bConsultWnsearchdir;
	//}}AFX_DATA
	BOOL	m_bSettingsChanged;

// Operations
	VOID PrepareMisc (VOID);

// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CWordNetOptions)
	public:
	virtual BOOL OnApply();
	virtual void OnOK();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	VOID ApplySettings (VOID);

	// Generated message map functions
	//{{AFX_MSG(CWordNetOptions)
	afx_msg void OnBrowse();
	afx_msg void OnConsultWnsearchdir();
	afx_msg void OnUseWordnet();
	afx_msg void OnChangeWordnetDataDirectory();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
