//	Copyleft 1993-1995 Tom O'Hara		A simple library of common stuff
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

#if !defined(_RTFEDIT_H)
#define _RTFEDIT_H


#ifndef __AFXEXT_H__
#include <afxext.h>
#endif
#include <richedit.h>           // For Richedit control

//-----------------------------------------------------------------------------

CONST CHAR pszEDIT[] = 		"EDIT";
CONST CHAR pszRICHEDIT[] = 	"RICHEDIT";

class CRtfEdit : public CEditx
{
	DECLARE_DYNCREATE(CRtfEdit)
public:
	CRtfEdit();
	virtual ~CRtfEdit ();
// Operations
	virtual BOOL Create (DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID);
	virtual BOOL SetText (CONST CStringx& sText);
	virtual VOID ChangeBackgroundColor (COLORREF color);
	virtual VOID ChangeTextColor (COLORREF color);
	virtual PWNDPROC GetSuperWndProcAddr (void);
	virtual VOID ChangeFont (void);
	virtual DWORD SetTextCallback (DWORD dwCookie, PBYTE pbBuff, LONG cb, PLONG pcb);
	virtual LRESULT SplatTextToDC (CDC* pDC, CRect& rDrawTo, CRect& rPage, BOOL bPrinterDC);
	virtual VOID StupidSetSel (INT nStartChar, INT nEndChar);
// Implementation
private:
	// class-wide members
	static HINSTANCE m_hRTFLib;			// module handle to DLL for RTF control
	static PCSZ m_pszEditControl;		// class name to use (RICHEDIT vs vanilla EDIT)
private:
	CONST CStringx* m_psInText;			// pointer to text being streamed in
	INT m_nPos;							// current position in the buffer
	VOID LoadRtfLibrary (VOID);
protected:
	// Generated message map functions
	//{{AFX_MSG(CRtfEdit)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


#endif	// !defined(_RTFEDIT_H)
