//	Copyleft 1993-1996 Tom O'Hara		Lookup source
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

#if !defined(_COMMON_LOOKUP_H)
#define _COMMON_LOOKUP_H


#if defined(__cplusplus)
extern "C" {
#endif

//	Constants
//

//	Sgml-like tags to use for the lookup results
#define PARA				"par"
#define HEADWORD			"head"
#define ENTRY				"entry"
#define BOLD				"hp1"
#define ITALICS				"hp2"
#define ANNOTATION			"ann"
#define PART_OF_SPEECH		"pos"
#define SGML_START_TAG(base)	"<" base ">"
#define SGML_END_TAG(base)		"</" base ">"
#define SEP_SGML_START_TAG(base)	"\r\n<" base ">\r\n"
#define SEP_SGML_END_TAG(base)		"\r\n</" base ">\r\n"

CONST CHAR szSGML_START_PARA[] =	SEP_SGML_START_TAG(PARA);
CONST CHAR szSGML_END_PARA[] =		SEP_SGML_END_TAG(PARA);
CONST CHAR szSGML_START_HEAD[] =	SEP_SGML_START_TAG(HEADWORD);
CONST CHAR szSGML_END_HEAD[] =		SEP_SGML_END_TAG(HEADWORD);
CONST CHAR szSGML_START_ENTRY[] =	SEP_SGML_START_TAG(ENTRY);
CONST CHAR szSGML_END_ENTRY[] =		SEP_SGML_END_TAG(ENTRY);
CONST CHAR szSGML_START_BOLD[] =	SEP_SGML_START_TAG(BOLD);
CONST CHAR szSGML_END_BOLD[] =		SEP_SGML_END_TAG(BOLD);
CONST CHAR szSGML_START_ITALICS[] =	SEP_SGML_START_TAG(ITALICS);
CONST CHAR szSGML_END_ITALICS[] =	SEP_SGML_END_TAG(ITALICS);
CONST CHAR szSGML_START_ANNOTATION[] = 	SEP_SGML_START_TAG(ANNOTATION);
CONST CHAR szSGML_END_ANNOTATION[] = 	SEP_SGML_END_TAG(ANNOTATION);
CONST CHAR szSGML_START_PART_OF_SPEECH[] = 	SEP_SGML_START_TAG(PART_OF_SPEECH);
CONST CHAR szSGML_END_PART_OF_SPEECH[] = 	SEP_SGML_END_TAG(PART_OF_SPEECH);

//  Type declarations
//

//  enumerated type for lookup request type
typedef enum {eDEFINITION=1, eSYNONYMS, eCROSS_REFS, eDESCENDANTS, eNONE=-1} LOOKUP_TYPE;

#if defined(__cplusplus)
    }
#endif

#endif  // !defined(_COMMON_LOOKUP_H)
