// MvLookup.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "MvLookup.h"
#include "MvLookupDlg.h"

IMPLEMENT_DYNCREATE(CMvInfo, CWinThread);
IMPLEMENT_DYNAMIC(CMvLookup, CObject);

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMvLookupDll

BEGIN_MESSAGE_MAP(CMvLookupDll, CWinApp)
	//{{AFX_MSG_MAP(CMvLookupDll)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMvLookupDll construction

CMvLookupDll::CMvLookupDll(VOID)
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CMvLookupDll object

CMvLookupDll theApp;


BOOL CMvLookupDll::InitInstance() 
{
	INIT_COMMON(AfxGetInstanceHandle(), NULL, "MvLookup");
	INIT_DEBUGGING_("MvLookup.ini");

	return CWinApp::InitInstance();
}


#if FALSE
// NOTE: A single dialog is maintained to cut down on resources in MDI clients
//       such as Wordz.
//
CMvLookupDlg* pDlg = NULL;				// built-in dialog for doing lookups
HWND hDlg = NULL;						// handle for the build-in dialog


VOID InitMvLookup(CWnd* pMainFrame)
{
	DEBUG_OUT(TL_VERBOSE, ("InitMvLookup(%x)\n", pMainFrame));
	pDlg = new CMvLookupDlg(pWnd);
}

EXTERN VOID ShutdownMvLookup(VOID);
#endif



BOOL DoLock (CEvent& event)
{
	if (GetDebugOption("SkipLocks", TRUE)) {
		return (TRUE);
		}

	// Wait to access the phrase
	CSingleLock lock(&event);
	DWORD dwResult = lock.Lock(INFINITE);
	event.ResetEvent();
	if (dwResult == 0) {
		DEBUG_OUT(TL_BASIC, ("Problem waiting for event\n"));
		return (FALSE);
		}

	return (TRUE);
}

//-----------------------------------------------------------------------------
// CMvInfo
// 
// Interface class for accessing MediaView titles

#if FALSE
CMvInfo::CMvInfo (CWnd* pParentWnd, PCSZ pszTitle)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::CMvInfo(%x, %s)\n", pParentWnd, F(pszTitle)));

	m_hWndParent = pParentWnd ? pParentWnd->m_hWnd : NULL;
	m_sTitle = pszTitle;
	AfxThreadBegin();
	UNREFERENCED_PARAMETER(pszTitle);
}
#endif


CMvInfo::CMvInfo (VOID)
	: m_eventLookup(TRUE, TRUE),		 // lock this initially; manual reset
	m_eventResults(TRUE, TRUE),			 // and this; likewise, manual reset
	m_eventLookupPhrase(FALSE, TRUE),	 // but not this; likewise, manual reset
	m_eventLookupReferences(FALSE, TRUE) // ditto; likewise, manual reset
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::CMvInfo()\n"));
	Init();
}


CMvInfo::~CMvInfo (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::~CMvInfo()\n"));

#if FALSE
	CMvLookupDlg* pDlg = GetLookupDialog();
	if (pDlg && IsWindow(pDlg->m_hWnd)) {
		pDlg->DestroyWindow();
		pDlg = NULL;
	}
#endif
}


BOOL CMvInfo::InitInstance (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::InitInstance()\n"));

	//Init();
	LookupWorker();
	return (TRUE);
}


BOOL CMvInfo::Init (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::Init()\n"));

	//CWnd* pParentWnd = CWnd::FromHandle(m_hParentWnd);
	//CMvLookupDlg* pDlg = new CMvLookupDlg(pParentWnd);
	CMvLookupDlg* pDlg = new CMvLookupDlg(NULL);

	HINSTANCE hInst = theApp.m_hInstance;
	HRSRC hResource = ::FindResource(hInst, MAKEINTRESOURCE(IDD_MVLOOKUP_DIALOG), RT_DIALOG);
	HGLOBAL hTemplate = LoadResource(hInst, hResource);
	//BOOL bCreatedOK = pDlg->CreateIndirect(hTemplate, pParentWnd);
	BOOL bCreatedOK = pDlg->CreateIndirect(hTemplate, NULL);
	ASSERT(bCreatedOK);
	FreeResource(hTemplate);
	pDlg->ShowWindow(SW_HIDE);
	m_hDlg = pDlg->m_hWnd;
	ASSERT(m_hDlg);

#if FALSE
	if (pDlg->m_pMvNonScrollable == NULL) {
		pDlg->ForceInitDialog();
		}
#endif

#if TRUE
	if (!m_sTitle.IsEmpty()) {
		pDlg->OpenTitle(m_sTitle);
		}
#endif

	// Release the lock which is initially set
	// Also, release some of the others while we're at it
	m_eventLookup.SetEvent();
	m_eventResults.SetEvent();

	//LookupWorker();

	return (TRUE);
}


BOOL CMvInfo::ExitInstance (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::ExitInstance()\n"));

	CWnd* pDlg = CWnd::FromHandle(m_hDlg);
	if (pDlg) {
		pDlg->DestroyWindow();
		}

	return (TRUE);
}


// OpenTitle: Open a MediaView title
//
BOOL CMvInfo::OpenTitle (PCSZ pszTitle)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::OpenTitle('%s')\n", F(pszTitle)));

	CMvLookupDlg* pDlg = GetLookupDialog();
	BOOL bOK = pDlg && pDlg->OpenTitle(pszTitle);

	return (bOK);
}


BOOL CMvInfo::MtOpenTitle (PCSZ pszTitle)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::MtOpenTitle('%s')\n", F(pszTitle)));

	// Wait to access the main event object
	CSingleLock lockLookup(&m_eventLookup);
	DWORD dwResult = lockLookup.Lock(INFINITE);
	m_eventLookup.ResetEvent();
	if (dwResult == 0) {
		DEBUG_OUT(TL_BASIC, ("Problem waiting for m_eventLookup\n"));
		return (FALSE);
		}

	// Open the title and then signal that the lock is free
	CMvLookupDlg* pDlg = GetLookupDialog();
	BOOL bOK = pDlg && pDlg->OpenTitle(pszTitle);
	m_eventLookup.SetEvent();

	return (bOK);
}


// OpenTitle: Close the MediaView title
//
BOOL CMvInfo::CloseTitle (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::CloseTitle()\n"));

	CMvLookupDlg* pDlg = GetLookupDialog();
	BOOL bOK = pDlg && pDlg->CloseTitle();

	return (bOK);
}


BOOL CMvInfo::MtCloseTitle (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::MtCloseTitle()\n"));

	// Wait to access the main event object
	CSingleLock lockLookup(&m_eventLookup);
	DWORD dwResult = lockLookup.Lock(INFINITE);
	m_eventLookup.ResetEvent();
	if (dwResult == 0) {
		DEBUG_OUT(TL_BASIC, ("Problem waiting for m_eventLookup\n"));
		return (FALSE);
		}

	// Close the title and then signal that the lock is free
	CMvLookupDlg* pDlg = GetLookupDialog();
	BOOL bOK = pDlg && pDlg->CloseTitle();
	m_eventLookup.SetEvent();

	return (bOK);
}

// OpenWordWheel: Open the MediaView wordwheel with the given name
// Wordwheels are used for doing keyword lookup
//
BOOL CMvInfo::OpenWordWheel (PCSZ pszName)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::OpenWordWheel(%s)\n", F(pszName)));

	CMvLookupDlg* pDlg = GetLookupDialog();
	BOOL bOK = pDlg && pDlg->OpenWordWheel(pszName);

	return (bOK);
}


BOOL CMvInfo::MtOpenWordWheel (PCSZ pszName)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::MtOpenWordWheel(%s)\n", F(pszName)));

	// Wait to access the main event object
	CSingleLock lockLookup(&m_eventLookup);
	DWORD dwResult = lockLookup.Lock(INFINITE);
	m_eventLookup.ResetEvent();
	if (dwResult == 0) {
		DEBUG_OUT(TL_BASIC, ("Problem waiting for m_eventLookup\n"));
		return (FALSE);
		}

	// Open the word wheel and then signal that the lock is free
	CMvLookupDlg* pDlg = GetLookupDialog();
	BOOL bOK = pDlg && pDlg->OpenWordWheel(pszName);
	m_eventLookup.SetEvent();

	return (bOK);
}


// OpenTopicList: Open the MediaView topic list with the given name
// Topic lists are used for doing full-text search (for cross-references)
//
BOOL CMvInfo::OpenTopicList (PCSZ pszName)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::OpenTopicList(%s)\n", F(pszName)));

	CMvLookupDlg* pDlg = GetLookupDialog();
	BOOL bOK = pDlg && pDlg->OpenTopicList(pszName);

	return (bOK);
}


// OpenTopicList: Open the MediaView topic list with the given name
// Topic lists are used for doing full-text search (for cross-references)
//
BOOL CMvInfo::MtOpenTopicList (PCSZ pszName)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::MtOpenTopicList(%s)\n", F(pszName)));

	// Wait to access the main event object
	CSingleLock lockLookup(&m_eventLookup);
	DWORD dwResult = lockLookup.Lock(INFINITE);
	m_eventLookup.ResetEvent();
	if (dwResult == 0) {
		DEBUG_OUT(TL_BASIC, ("Problem waiting for m_eventLookup\n"));
		return (FALSE);
		}

	// Open the topic list and then signal that the lock is free
	CMvLookupDlg* pDlg = GetLookupDialog();
	BOOL bOK = pDlg && pDlg->OpenTopicList(pszName);
	m_eventLookup.SetEvent();


	return (bOK);
}


// DoLookupDialog: Invoke the built-in lookup dialog
// This just activates the dialog since it is shamelessly used anyway.
//
// NOTE: This really shouldn't be used in a multithreaded application
//
CWnd* CMvInfo::DoLookupDialog (CWnd* pParentWnd)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::DoLookupDialog(%x)\n", pParentWnd));
	UNREFERENCED_PARAMETER(pParentWnd);

	CMvLookupDlg* pDlg = GetLookupDialog();
	if (pDlg) {
		pDlg->ShowWindow(SW_SHOW);
		pDlg->SetFocus();
		pDlg->EnableControls();
		}

	return (pDlg);
}


// LookupWorker: Workhorse routine for waiting upon lookup requests
//
VOID CMvInfo::LookupWorker (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::LookupWorker()\n"));
	CString sResult;

	// Create an multiple-event lock for the two lookup request events
	CEvent* apEvents[2];
	apEvents[0] = &m_eventLookupPhrase;
	apEvents[1] = &m_eventLookupReferences;
	CMultiLock locks((CSyncObject**)apEvents, 2, FALSE);

	for (;;) {
		// Wait for the next request
		DWORD dwWaitResult = locks.Lock(INFINITE, FALSE); // wait forever for one of the events
		if (dwWaitResult == WAIT_OBJECT_0) {
			m_eventLookupPhrase.ResetEvent();
			sResult = LookupPhrase(m_sPhrase);
			m_eventLookup.SetEvent();
			}
		else if (dwWaitResult == (WAIT_OBJECT_0 + 1)) {
			m_eventLookupReferences.ResetEvent();
			sResult = LookupCrossReferences(m_sPhrase);
			m_eventLookup.SetEvent();
			}
		else {
			DEBUG_OUT(TL_BASIC, ("Problem waiting for MvLookup events (result=%lu)\n", dwWaitResult));
			}
		}
}


// MtLookupPhrase: Lookup the topics in the database given a phrase keyword
//
CString CMvInfo::MtLookupPhrase (PCSZ pszPhrase)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::MtLookupPhrase(%s)\n", F(pszPhrase)));
	CString sResult;

	DoLock(m_eventLookup);
#if FALSE
	// Wait to access the phrase
	CSingleLock lockLookup(&m_eventLookup);
	DWORD dwResult = lockLookup.Lock(INFINITE);
	m_eventLookup.ResetEvent();
	if (dwResult == 0) {
		DEBUG_OUT(TL_BASIC, ("Problem waiting for m_eventLookup\n"));
		return (sResult);
		}
#endif

	// Set the phrase and signal that a definition lookup is desired
	m_sPhrase = pszPhrase;
	m_eventLookupPhrase.SetEvent();

	DoLock(m_eventResults);
#if FALSE
	// Wait to access the results
	CSingleLock lockResults(&m_eventResults);
	lockResults.Lock(INFINITE);
	m_eventResults.ResetEvent();
	if (dwResult == 0) {
		DEBUG_OUT(TL_BASIC, ("Problem waiting for m_eventResults\n"));
		return (sResult);
		}
#endif

	// Access the results and signal that it is available
	sResult = m_sResults;
	m_eventResults.SetEvent();

	return (sResult);
}


// MtLookupReferences: Lookup the topics in the database given a phrase keyword
//
CString CMvInfo::MtLookupCrossReferences (PCSZ pszReferences)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::MtLookupCrossReferences (%s)\n", F(pszReferences)));
	CString sResult;

	// Wait to access the phrase
	CSingleLock lockLookup(&m_eventLookup);
	DWORD dwResult = lockLookup.Lock(INFINITE);
	m_eventLookup.ResetEvent();
	if (dwResult == 0) {
		DEBUG_OUT(TL_BASIC, ("Problem waiting for m_eventLookup\n"));
		return (sResult);
		}

	// Set the phrase and signal that a cross reference lookup is desired
	m_sPhrase = pszReferences;
	m_eventLookupReferences.SetEvent();

	// Wait to access the results
	CSingleLock lockResults(&m_eventResults);
	lockResults.Lock(INFINITE);
	m_eventResults.ResetEvent();
	if (dwResult == 0) {
		DEBUG_OUT(TL_BASIC, ("Problem waiting for m_eventResults\n"));
		return (sResult);
		}

	// Access the results and signal that it is available
	sResult = m_sResults;
	m_eventResults.SetEvent();

	return (sResult);
}


// LookupPhrase: Lookup the topics in the database given a phrase keyword
//
CString CMvInfo::LookupPhrase (PCSZ pszPhrase)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::LookupPhrase(%s)\n", F(pszPhrase)));
	CString sResults;

	CMvLookupDlg* pDlg = GetLookupDialog();
	if (pDlg) {
		pDlg->m_sPhrase = pszPhrase;
		pDlg->LookupPhrase();
		sResults = pDlg->m_sResult;
		}
	m_eventLookupPhrase.SetEvent();

	return (sResults);
}


// LookupCrossReferences: Lookup the topics that contain a given phrase
//
CString CMvInfo::LookupCrossReferences (PCSZ pszPhrase)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::LookupCrossReferences(%s)\n", F(pszPhrase)));
	CString sResult;

	CMvLookupDlg* pDlg = GetLookupDialog();
	if (pDlg) {
		pDlg->m_sPhrase = pszPhrase;
		pDlg->LookupCrossReferences();
		sResult = pDlg->m_sResult;
		}

	return (sResult);
}


// GetLookupDialog: Return a temporary pointer to the MvLookup dialog
//
CMvLookupDlg* CMvInfo::GetLookupDialog (VOID)
{
#if FALSE
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::GetLookupDialog()\n"));
	//CMvLookupDlg* pDlg = ToCMvLookupDlg(CWnd::FromHandlePermanent(m_hDlg));
	CMvLookupDlg* pDlg = (CMvLookupDlg*)(CWnd::FromHandlePermanent(m_hDlg));
	//CMvLookupDlg* pDlg = (CMvLookupDlg*)(CWnd::FromHandle(m_hDlg));
	ASSERT(pDlg);

	return (pDlg);
#endif

	return (m_pDlg);
}

//-----------------------------------------------------------------------------
// CMvLookup
// 
// Interface class for actual lookup's


CMvLookup::CMvLookup (CMvInfo* pMvInfo)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookup::CMvLookup(%x)\n", 
							ToCMvInfo(pMvInfo)));
	m_pMvInfo = pMvInfo;
	m_bAddSgml = TRUE;
}


CMvLookup::~CMvLookup (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookup::~CMvLookup()\n"));
}


// LookupPhrase: Lookup the topics in the database given a phrase keyword
//
CString CMvLookup::LookupPhrase (PCSZ pszPhrase)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookup::LookupPhrase(%s)\n", F(pszPhrase)));
	CString sResult;
	ASSERT_VALID(m_pMvInfo);

	CMvLookupDlg* pDlg = m_pMvInfo ? m_pMvInfo->GetLookupDialog() : NULL;
	if (pDlg) {
		pDlg->m_sPhrase = pszPhrase;
		pDlg->LookupPhrase();
		sResult = pDlg->m_sResult;
		}

	return (sResult);
}


CString CMvLookup::MtLookupPhrase (PCSZ pszPhrase)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookup::MtLookupPhrase(%s)\n", F(pszPhrase)));
	CString sResult;
	ASSERT_VALID(m_pMvInfo);

	if (m_pMvInfo) {
		sResult = m_pMvInfo->MtLookupPhrase(pszPhrase);
		}

	return (sResult);
}


// LookupCrossReferences: Lookup the topics that contain a given phrase
//
CString CMvLookup::LookupCrossReferences (PCSZ pszPhrase)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookup::LookupCrossReferences(%s)\n", F(pszPhrase)));
	CString sResult;
	ASSERT_VALID(m_pMvInfo);

	CMvLookupDlg* pDlg = m_pMvInfo ? m_pMvInfo->GetLookupDialog() : NULL;
	if (pDlg) {
		pDlg->m_sPhrase = pszPhrase;
		pDlg->LookupCrossReferences();
		sResult = pDlg->m_sResult;
		}

	return (sResult);
}


CString CMvLookup::MtLookupCrossReferences (PCSZ pszPhrase)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookup::MtLookupCrossReferences(%s)\n", F(pszPhrase)));
	CString sResult;
	ASSERT_VALID(m_pMvInfo);

	if (m_pMvInfo) {
		sResult = m_pMvInfo->MtLookupCrossReferences(pszPhrase);
		}

	return (sResult);
}


// UseSgml: Indicate whether the results should be formatted with (pseudo) SGML
//
VOID CMvLookup::UseSgml (BOOL bUseSgml /* = TRUE */)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookup::UseSgml(%d)\n", bUseSgml));
	ASSERT_VALID(m_pMvInfo);

	CMvLookupDlg* pDlg = m_pMvInfo ? m_pMvInfo->GetLookupDialog() : NULL;
	if (pDlg) {
		pDlg->m_bAddSgml = bUseSgml;
		}
}


//-----------------------------------------------------------------------------
// Interface functions


// InitMvInfo: Creates a thread with CMvInfo and returns the object pointer
//

//CMvInfo* InitMvInfo (CWnd* pWnd, PCSZ pszTitle)

CMvInfo* CreateMvInfo (VOID)
{
	CMvInfo* pMvInfo = (CMvInfo*)AfxBeginThread(RUNTIME_CLASS(CMvInfo));
	if (pMvInfo) {
		//HWND hWndParent = pWnd ? pWnd->m_hWnd : NULL;
		//pMvInfo->Init(hWndParent, pszTitle);
		//pMvInfo->Init();
		}

	return (pMvInfo);
}
