// MvLookupDlg.cpp : implementation file
//
// Based on player sample from mv14 sdk
//

#include "stdafx.h"
#include "MvLookup.h"
#include "MvLookupDlg.h"
#include "CommonLookup.h"

//IMPLEMENT_DYNAMIC(CMvLookupDlg, CObject);

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CONST BOOL bSAVE_AND_VALIDATE = TRUE;
CONST BOOL bINITIALIZE = !bSAVE_AND_VALIDATE;

CONST CHAR cLEFT_PAREN = '(';
CONST CHAR szLEFT_PAREN[] = "(";
CONST CHAR cRIGHT_PAREN = ')';
CONST CHAR szSENSE_FMT[] = "{%d}";
CONST CHAR szCRLF[] = "\r\n";
CONST CHAR szTAB[] = "\t";

INLINE INT StringToInt (PCSZ pszText)
{
	return ((INT)StringToLong(pszText));
}

// FindStringIgnoreCase: Find the position of the target string in the source without
// regard for case. This uses the brute-force approach.
//
INT FindStringIgnoreCase (PCSZ pszSource, PCSZ pszTarget)
{
	DEBUG_OUT(TL_GARRULOUS, ("FindStringIgnoreCase('%s', '%s')\n", pszSource, pszTarget));

	PCSZ pszSourceAnchor = pszSource;
	BOOL bFound = FALSE;
	while (*pszSourceAnchor && !bFound) {
		PCSZ pszSourcePos = pszSourceAnchor;
		PCSZ pszTargetPos = pszTarget;
		bFound = TRUE;
		while (*pszTargetPos) {
			if (ToUpper(*pszSourcePos) != ToUpper(*pszTargetPos)) {
				bFound = FALSE;
				break;
				}
			pszSourcePos++;
			pszTargetPos++;
			}
		if (!bFound) {
			pszSourceAnchor++;
			}
		}
	INT nPos = bFound ? (pszSourceAnchor - pszSource) : nINVALID_INDEX;

	return (nPos);
}


// Parts of speech labels (in a string format suitable for a resource)
// NOTE: the list must be ordered so that the most specific entries
// come first (that is, "plural noun" before "noun")
//
CONST CHAR szPartsOfSpeech[] = 
	"adjective\t"
	"adverb\t"
	"conjunction\t"
	"definite article\t"
	"indefinite article\t"
	"interjection\t"
	"plural noun\t"
	"preposition\t"
	"pronoun\t"
	"singular noun\t"
	"verb, intransitive\t"
	"verb, transitive\t"
	"noun\t"
	"verb\t"
	;


/////////////////////////////////////////////////////////////////////////////
// CMvLookupDlg dialog

CMvLookupDlg::CMvLookupDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMvLookupDlg::IDD, pParent)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDlg::CMvLookupDlg(%x)\n", pParent));

	//{{AFX_DATA_INIT(CMvLookupDlg)
	m_sPhrase = _T("");
	m_sResult = _T("");
	m_bAddSgml = TRUE;
	//}}AFX_DATA_INIT
	m_hTitle = NULL;
	m_hTopicList = NULL;
	m_hWordWheel = NULL;
	m_pMvNonScrollable = NULL;
	m_pMvScrollable = NULL;
	m_bKeySearch = TRUE;

	// Fill in the parts of speech array
	TokenizeText(m_asPartOfSpeech, szPartsOfSpeech, szTAB);
}


void CMvLookupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMvLookupDlg)
	DDX_Control(pDX, IDC_PHRASE, m_editResults);
	DDX_Control(pDX, IDC_SEARCH_TYPE, m_radioSearchType);
	DDX_Control(pDX, IDC_STATIC_SR, m_staticScrollable);
	DDX_Control(pDX, IDC_STATIC_NSR, m_staticNonScrollable);
	DDX_Control(pDX, IDC_GROUPS, m_comboGroups);
	DDX_Control(pDX, IDC_KEYWORDS, m_comboKeywordGroups);
	DDX_Text(pDX, IDC_PHRASE, m_sPhrase);
	DDX_Text(pDX, IDC_RESULT, m_sResult);
	DDX_Check(pDX, IDC_ADD_SGML, m_bAddSgml);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMvLookupDlg, CDialog)
	//{{AFX_MSG_MAP(CMvLookupDlg)
	ON_BN_CLICKED(IDC_CLOSE_TITLE, OnCloseTitle)
	ON_BN_CLICKED(IDC_OPEN_TITLE, OnOpenTitle)
	ON_CBN_SELCHANGE(IDC_GROUPS, OnSelchangeGroups)
	ON_CBN_SELCHANGE(IDC_KEYWORDS, OnSelchangeKeywords)
	ON_BN_CLICKED(IDC_KEYWORD_SEARCH, OnKeywordSearch)
	ON_BN_CLICKED(IDC_FULL_TEXT_SEARCH, OnFullTextSearch)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMvLookupDlg message handlers

BOOL CMvLookupDlg::OnInitDialog()
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDlg::OnInitDialog()\n"));

	CDialog::OnInitDialog();

	InitMediaView();
	EnableControls();
	
	CheckRadioButton(IDC_KEYWORD_SEARCH, IDC_FULL_TEXT_SEARCH, 
					 m_bKeySearch ? IDC_KEYWORD_SEARCH : IDC_FULL_TEXT_SEARCH);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

VOID CMvLookupDlg::OnDestroy() 
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDlg::OnDestroy()\n"));

	CDialog::OnDestroy();
	CleanupMediaView();
}


// Init MediaView access
VOID CMvLookupDlg::InitMediaView (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDlg::InitMediaView()\n"));

	// Set the instance handle
	::MVSetInstance(AfxGetInstanceHandle());

#if FALSE
	// Get the file name of the title (default to Bookshelf)
	m_sTitle = AfxGetApp()->m_lpCmdLine;
	if (m_sTitle.IsEmpty()) {
		m_sTitle = "g:\\books\\Bshelf95.m14";
	}
#endif

	// Create MediaView objects for rendering the scrollable and nonscrollable 
	// parts of the topic.
	BOOL bAssocOK;
	m_pMvNonScrollable = lpMVNew(NULL, &m_err);
	bAssocOK = fMVSetWindow(m_pMvNonScrollable, m_staticNonScrollable.GetSafeHwnd(), &m_err);
	ASSERT(bAssocOK);
	m_pMvScrollable = lpMVNew(NULL, &m_err);
	bAssocOK = fMVSetWindow(m_pMvScrollable, m_staticScrollable.GetSafeHwnd(), &m_err);
	ASSERT(bAssocOK);

	// Open the title
	if (!m_sTitle.IsEmpty()) {
		OpenTitle();
	}
}
	

// Clean up MediaView stuff
//
VOID CMvLookupDlg::CleanupMediaView (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDlg::CleanupMediaView()\n"));

	CloseTitle();

	if (m_pMvNonScrollable) {
		MVDelete(m_pMvNonScrollable);
		m_pMvNonScrollable = NULL;
	}
	if (m_pMvScrollable) {
		MVDelete(m_pMvScrollable);
		m_pMvScrollable = NULL;
	}


	::MVTerminate(AfxGetInstanceHandle());
}


CONST INT nMAX_NAME = 512;


BOOL CMvLookupDlg::OpenTitle (CONST CString& sTitle)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDlg::OpenTitle(%s)\n", F(sTitle)));
	m_sTitle = sTitle;

	// Close the existing title, if any
	OpenTitle();

	return (m_hTitle != NULL);
}


VOID CMvLookupDlg::OpenTitle (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDlg::OpenTitle()\n"));

	// Close the existing title, if any
	CloseTitle();

	// Open the title file
	// TODO: add an interrupt call back
	m_hTitle = hMVTitleOpen(m_sTitle);
	if (m_hTitle == NULL) {
		CString sError;
		sError.Format("Unable to open the title:\n\t'%s'", (PCSZ)m_sTitle);
		AfxMessageBox(sError);
		return;
	}

	// Get the title name and use it in the app title
	CString sTitleName;
	PSZ pszName = sTitleName.GetBuffer(nMAX_NAME);
	lMVTitleGetInfo(m_hTitle, TTLINF_TITLE, nMAX_NAME, (LONG)pszName);
	sTitleName.ReleaseBuffer();
	CString sWindowTitle;
	sWindowTitle.Format("%s - %s", (PCSZ)AfxGetApp()->m_pszAppName, (PCSZ)sTitleName);
	SetWindowText(sWindowTitle);

	// Associate the title with the MediaView object
	fMVSetTitle(m_pMvNonScrollable, m_hTitle, sTitleName, &m_err);
	fMVSetTitle(m_pMvScrollable, m_hTitle, sTitleName, &m_err);

	// Reset the group combox boxes
	m_comboGroups.ResetContent();
	m_comboKeywordGroups.ResetContent();

	CStringx sGroup;
	LRESULT lRes = 0;
	INT nGroup;

	// Extract the searchable group titles from the title and add to the list
	// Based on MV_LoadGroups in MediaView sample
	DEBUG_OUT(TL_VERBOSE, ("Title Groups:\n"))
	for (nGroup = 0; lRes != -1; nGroup++) {
		PSZ pszGroup = sGroup.GetBuffer(nMAX_NAME);
		lRes = ::lMVTitleGetInfo(m_hTitle, TTLINF_GROUPS, MAKELONG(nMAX_NAME, nGroup),
								(LONG)pszGroup);
		sGroup.ReleaseBuffer();
		if (lRes != -1) {
			DEBUG_OUT(TL_VERBOSE, ("Group %d: %s\n", nGroup, (PCSZ)sGroup))
			// Extract the group name & title ('name.grp "title"')
			INT nPos = 0;
			CString sName = ExtractToken(sGroup, nPos, '.');
			m_sGroupName.SetAtGrow(nGroup, sName);
			nPos = sGroup.FindAt(nPos, '\"');
			CString sTitle = ExtractToken(sGroup, nPos, ";");

			// Associate the group name with the title
			if (!sTitle.IsEmpty()) {
				INT nIndex = m_comboGroups.AddString(sTitle);
				ASSERT(nIndex != LB_ERR);
				PCSZ pszGroup = m_sGroupName[nGroup];
				m_comboGroups.SetItemData(nIndex, (DWORD)pszGroup);
			}
		}
	}
	m_comboGroups.SetCurSel(0);

	// Get the keyword groups
	DEBUG_OUT(TL_VERBOSE, ("Keyword Groups:\n"))
	CHAR cGroup = '?';
	for (nGroup = 0; cGroup != '\0'; nGroup++) {
		PSZ pszGroup = sGroup.GetBuffer(nMAX_NAME);
		cGroup = (CHAR)::lMVTitleGetInfo(m_hTitle, TTLINF_KEYINDEX, 
										 MAKELONG(nMAX_NAME, nGroup), (LONG)pszGroup);
		sGroup.ReleaseBuffer();
		if (lRes != 0) {
			DEBUG_OUT(TL_VERBOSE, ("Group %d: %s\n", nGroup, (PCSZ)sGroup))
			INT nIndex = m_comboKeywordGroups.AddString(sGroup);
			ASSERT(nIndex != LB_ERR);
			m_comboKeywordGroups.SetItemData(nIndex, cGroup);
		}
	}
	m_comboKeywordGroups.SetCurSel(0);

	OpenWordWheel();
	OpenTopicList();
}


BOOL CMvLookupDlg::CloseTitle (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDlg::CloseTitle()\n"));
	BOOL bOK = FALSE;

	if (m_hTitle != NULL) {
		::MVTitleClose(m_hTitle);
		m_hTitle = NULL;
		CString sWindowTitle;
		sWindowTitle.Format("%s", (PCSZ)AfxGetApp()->m_pszAppName);
		SetWindowText(sWindowTitle);
		bOK = TRUE;
	}
	CloseWordWheel();
	CloseTopicList();

	return (bOK);
}

	
BOOL CMvLookupDlg::OpenWordWheel (PCSZ pszWordWheel)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDlg::OpenWordWheel(%s)\n", F(pszWordWheel)));
	ASSERT(m_hTitle);
	CloseWordWheel();

	// Derive Wordwheel name: "|<name_char>"
	INT nPos = m_comboKeywordGroups.FindStringExact(0, pszWordWheel);
	CString sTitle;
	m_comboKeywordGroups.GetLBText(nPos, sTitle);
	CHAR cName = (CHAR)m_comboKeywordGroups.GetItemData(nPos);
	CString sWordWheel;
	sWordWheel.Format("|%c", cName);

	// Open the wordwheel (which has the keyword list)
	m_hWordWheel = ::hMVWordWheelOpenTitle(m_hTitle, sWordWheel);
	DEBUG_OUT(TL_VERBOSE, ("%x <= hMVWordWheelOpenTitle(%x, %s): name=%s\n", 
			  m_hWordWheel, m_hTitle, F(sWordWheel), F(sTitle)));
   	if (m_hWordWheel == NULL) {
		DEBUG_OUT(TL_DETAILED, ("WordWheel open failure for '%s'\n", F(sWordWheel)));
	}

	return (m_hWordWheel != NULL);
}


VOID CMvLookupDlg::OpenWordWheel (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDlg::OpenWordWheel()\n"));
	ASSERT(m_hTitle);
	CloseWordWheel();

	// Derive Wordwheel name: "|<name_char>"
	INT nCurrent = m_comboKeywordGroups.GetCurSel();
	CString sTitle;
	m_comboKeywordGroups.GetLBText(nCurrent, sTitle);
	CHAR cName = (CHAR)m_comboKeywordGroups.GetItemData(nCurrent);
	CString sWordWheel;
	sWordWheel.Format("|%c", cName);

	// Open the wordwheel (which has the keyword list)
	m_hWordWheel = ::hMVWordWheelOpenTitle(m_hTitle, sWordWheel);
	DEBUG_OUT(TL_VERBOSE, ("%x <= hMVWordWheelOpenTitle(%x, %s): name=%s\n", 
			  m_hWordWheel, m_hTitle, F(sWordWheel), F(sTitle)));
   	if (m_hWordWheel == NULL) {
		DEBUG_OUT(TL_DETAILED, ("WordWheel open failure for '%s'\n", F(sWordWheel)));
	}
}


VOID CMvLookupDlg::CloseWordWheel (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDlg::CloseWordWheel()\n"));

	if (m_hWordWheel != NULL) {
		::MVWordWheelClose(m_hWordWheel);
		m_hWordWheel = NULL;
	}
}


BOOL CMvLookupDlg::OpenTopicList (PCSZ pszTopic)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDlg::OpenTopicList(%s)\n", F(pszTopic)));
	ASSERT(m_hTitle);
	CloseTopicList();

	// Use the current group name as the topic list name
	INT nPos = m_comboGroups.FindStringExact(0, pszTopic);
	PCSZ pszGroupName = (PCSZ)m_comboGroups.GetItemData(nPos);
	ASSERT(pszGroupName && AfxIsValidString(pszGroupName));
	// m_comboGroups.GetLBText(nCurrent, sGroup);
	m_hTopicList = ::hMVTopicListLoad(m_hTitle, pszGroupName);
	DEBUG_OUT(TL_VERBOSE, ("%x <= hMVTopicListLoad(%x, %s)\n", 
			  m_hTopicList, m_hTitle, F(pszGroupName)));

	return (m_hTopicList != NULL);
}


VOID CMvLookupDlg::OpenTopicList (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDlg::OpenTopicList()\n"));
	ASSERT(m_hTitle);
	CloseTopicList();

	// Use the current group name as the topic list name
	INT nCurrent = m_comboGroups.GetCurSel();
	PCSZ pszGroupName = (PCSZ)m_comboGroups.GetItemData(nCurrent);
	ASSERT(pszGroupName && AfxIsValidString(pszGroupName));
	// m_comboGroups.GetLBText(nCurrent, sGroup);
	m_hTopicList = ::hMVTopicListLoad(m_hTitle, pszGroupName);
	DEBUG_OUT(TL_VERBOSE, ("%x <= hMVTopicListLoad(%x, %s)\n", 
			  m_hTopicList, m_hTitle, F(pszGroupName)));
	ASSERT(m_hTopicList);
}


VOID CMvLookupDlg::CloseTopicList (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDlg::CloseTopicList()\n"));

	if (m_hTopicList != NULL) {
		::MVTopicListDestroy(m_hTopicList);
		m_hTopicList = NULL;
	}
}


// TopicTextToLookupSgml: Convert the MediaView topic text into lookup SGML.
// This will consist of the topic embedded within <head>...</head> tags
// plus ad hoc indicators (eg, <hp1>Pathology</hp1>).
//
// Each SGML tag is placed on a separate line to facilate parsing, so the
// result will look something like the following(1):
//
//		<head>
//		monster
//		</head>
//		monster (mnster) noun
//		1.	a. An imaginary or legendary creature, such as a centaur or Harpy, 
//		that combines parts from various animal or human forms. b. A creature 
//		having a strange or frightening appearance.
//		2.	An animal, a plant, or other organism having structural defects 
//		or deformities. 3.	Pathology. A fetus or an infant that is grotesquely 
//		abnormal and usually not viable.4.	A very large animal, plant, or object.
//		5.	One who inspires horror or disgust: a monster of selfishness.
//		[Middle English monstre, from Old French, from Latin monstrum, portent, 
//		monster, from monre, to warn.]
//
// (1) The American Heritage Dictionary of the English Language
//
// NOTE: the parameters may be modified
//
// TODO: translate SGML special characters into character entities (eg, &lt.)
//		 tag the pronunciation, part of speech, and etymology
//		 don't modify the parameters
//
CString CMvLookupDlg::TopicTextToLookupSgml (CString& sTopicHeader, CString& sTopicBody)
{
	DEBUG_OUT(TL_GARRULOUS, ("CMvLookupDlg::TopicTextToLookupSgml(%s, %s)\n", 
			  F1(sTopicHeader), F2(sTopicBody)));
	CString sResult;

	// If there is no topic header, just return the body without tags
	sTopicHeader.TrimLeft();
	sTopicHeader.TrimRight();
	if (sTopicHeader.GetLength() == 0) {
		DEBUG_OUT(TL_BASIC, ("WARNING: [TopicTextToLookupSgml] empty topic line (nonscrolling region)\n"));
		return (sTopicBody);
		}

	// Since the nonscrollable region contains the topic name, format
	// this within SGML <head> tags:
	//		<head>monster</head>
	//

	// Add the starting tag
	sResult += szSGML_START_HEAD;

	// Isolate the name from the optional the sense indicator (eg, "scrap2")
	// Format the sense with braces instead of parens (eg, "{2}")
	// This makes sure the number isn't part of the entry (? "H2O")
	// TODO: determine if any entries really end in numbers
	CString sName;
	CString sSense;
	INT nLast = sTopicHeader.GetLength();
	if (IsDigit(sTopicHeader[nLast - 1])
			&& (sTopicHeader.GetLength() > 1)
			&& (!IsDigit(sTopicHeader[nLast - 2]))) {
		nLast--;
		INT nPos = nLast;
		INT nSense = StringToInt(sTopicHeader, nPos);
		ASSERT(nSense > 0);
		if (nSense > 0) {
			sSense.Format(szSENSE_FMT, nSense);
			}
		}
	sName = sTopicHeader.Left(nLast);

	// Add the name and optional sense indicator (no intervenig space)
	sResult += sName;
	sResult += sSense;

	// Add the ending tag
	sResult += szSGML_END_HEAD;

	// Format the rest with ad hoc formatting
	// TODO: key this off of the wordwheel name (eg, dictionary vs thesaurus)

	// Ignore the repeated head word
	CStringx sBody = sTopicBody;
	sBody.TrimLeft();
	INT nPos = 0;
	if (sBody.Find(sName) == 0) {
		nPos += sName.GetLength();
		}

	// Copy over the body, tagging part of speech indicators
	//
	// Here's an example for the dictionary entry of "scrap".
	//
	//		scrap (skrp) noun
	//		1.	A small piece or bit; a fragment.
	//		2.	scraps. Leftover bits of food.
	//		3.	Discarded waste material, especially metal suitable for reprocessing.
	//		4.	scraps. Crisp pieces of rendered animal fat; cracklings.
	//	
	//		verb, transitive
	//		scrapped, scrapping, scraps
	//		1.	To break down into parts for disposal or salvage.
	//		2.	To discard as worthless; junk.
	//		[Middle English, from Old Norse skrap, trifles, pieces.]
	//
	// Note that there are CR/NL characters after each line shown above.
	// Also, the parts of speech indicators appear only to occur at the end of
	// lines, so elsewhere they won't be tagged (in case definition text uses
	// partof speech word).
	//
	// TODO: tag the sense numbers
	//
	while (nPos < sBody.GetLength()) {
		CStringx sLine = ExtractToken(sBody, nPos, szCRLF);
		CString sPartOfSpeech;

		// Check for the most specific part of speech label that applies
		// The array is ordered with most-specific first (eg, "transitive verb"
		// before "verb")
		for (INT i = 0; i < m_asPartOfSpeech.GetSize(); i++) {
			INT nLinePos = sLine.Find(m_asPartOfSpeech[i]);
			if ((nLinePos != nINVALID_INDEX)
					&& ((nLinePos + m_asPartOfSpeech[i].GetLength())
						== sLine.GetLength())) {
				sLine = sLine.Left(nLinePos);
				sPartOfSpeech += szSGML_START_PART_OF_SPEECH;
				sPartOfSpeech += m_asPartOfSpeech[i];
				sPartOfSpeech += szSGML_END_PART_OF_SPEECH;
				break;
				}
			}

		// Add the line text plus optional part of speech label
		sResult += sLine;
		sResult += sPartOfSpeech;
		sResult += szCRLF;
		}

	return (sResult);
}


// ReferenceToLookupSgml: Format the topic name with lookup SGML.
// This will consist of the topic name within <head> ... </head> tags.
//
// Each SGML tag is placed on a separate line to facilate parsing:
//		<head>
//		teratoid
//		</head>
//
// NOTE: The parameter may be modified
//
// TODO: don't modify the parameters
//
CString CMvLookupDlg::ReferenceToLookupSgml (CString& sTopicName)
{
	DEBUG_OUT(TL_GARRULOUS, ("CMvLookupDlg::TopicTextToLookupSgml(%s)\n",
			  F1(sTopicName)));
	CString sResult;

	// Make sure the topic name is valid
	// Skip over the section indicator (eg, "4monster")
	sTopicName.TrimLeft();
	sTopicName.TrimRight();
	INT nNameStart = 0;
	if ((sTopicName.GetLength() > 0) && IsDigit(sTopicName[0])) {
		nNameStart += 1;
		}
	if (nNameStart == sTopicName.GetLength()) {
		DEBUG_OUT(TL_BASIC, ("ERROR: TopicTextToLookupSgml called with bad topic name ('%s')",
				  F1(sTopicName)));
		}

	// Format the reference topic name within SGML <head> tags:
	//		<head>teratoid</head>
	//

	// Add the starting tag
	sResult += szSGML_START_HEAD;

	// Isolate the name from the optional the sense indicator (eg, "scrap (2)")
	// Format the sense with braces instead of parens (eg, "{1}")
	CString sName;
	CString sSense;
	INT nSenseStart = Pos(sTopicName, cLEFT_PAREN);
	if (nSenseStart == nINVALID_INDEX) {
		nSenseStart = sTopicName.GetLength();
		}
	else {
		INT nPos = nSenseStart + 1;
		INT nSense = StringToInt(sTopicName, nPos);
		ASSERT(nSense > 0);
		if (nSense > 0) {
			sSense.Format(szSENSE_FMT, nSense);
			}
		}
	INT nNameLen = nSenseStart - nNameStart;
	sName = sTopicName.Mid(nNameStart, nNameLen);
	sName.TrimRight();

	// Add the name and optional sense indicator (no intervening space)
	sResult += sName;
	sResult += sSense;

	// Add the ending tag
	sResult += szSGML_END_HEAD;

	return (sResult);
}


// LookupPhrase: Lookup the topic text given a keyword phrase
// The results will optionally be formatted with pseudo-SGML
//
VOID CMvLookupDlg::LookupPhrase (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDlg::LookupPhrase(): m_sPhrase=%s\n",
			  F(m_sPhrase)));
	ASSERT(m_hTitle != NULL);

	m_mapProcessed.RemoveAll();
	m_sResult.Empty();

	// Get the number of topics from the word wheel
	// TODO: figure out why extraneous topics are being returned
	PSZ pszPhrase = (PSZ)((PCSZ)m_sPhrase);
	m_nNumKeyTopics = ::nMVKeyIndexGetCount(m_hWordWheel, (LPBYTE)pszPhrase);
	if (m_nNumKeyTopics == ((WORD)-1)) {
		DEBUG_OUT(TL_DETAILED, ("error in nMVKeyIndexGetCount\n"));
		return;
		}	
	if (m_nNumKeyTopics > 100) {
		DEBUG_OUT(TL_DETAILED, ("NumKeyTopics reduced to 100 from %d\n", m_nNumKeyTopics));
		m_nNumKeyTopics = 100;
	}

	// Get the ADDR ptrs for the lookup
	m_KeyAddrs.SetAtGrow(m_nNumKeyTopics, 0);
	PDWORD pKeyAddrs = m_KeyAddrs.GetData();
	LRESULT lRet;
	lRet = ::lMVKeyIndexGetAddrs(m_hWordWheel, (LPBYTE)pszPhrase, 0, m_nNumKeyTopics, (LPBYTE)pKeyAddrs);

	// Add the text from each unique topic to the result buffer
	DEBUG_OUT(TL_VERBOSE, ("Index hits:\n"));
	for (INT i = 0; i < m_nNumKeyTopics; i++) {
		BOOL bProcess = FALSE;

		// Change the MediaView address in order to get at the name
		VA tmpVa = ::vaMVConvertAddr(m_hTitle, m_KeyAddrs[i]);
		::fMVSetAddress(m_pMvNonScrollable, tmpVa, nMV_NSR, 0, &m_err);
		::fMVSetAddress(m_pMvScrollable, tmpVa, nMV_SR, 0, &m_err);
		LPMV lpMV = GetMediaView();

		// Access topic title string
		HANDLE hName = hMVGetName(lpMV);
		PSZ pszName = (PSZ)GlobalLock(hName);

		// See if this topic was already processed
		INT nTopic = lMVTopicNumber(lpMV);
		DEBUG_OUT(TL_VERBOSE, ("\t%s\t%x\t[%d]\n", pszName, tmpVa, nTopic));
		INT nValue;
		if (m_mapProcessed.Lookup(nTopic, nValue) == FALSE) {
			CONST CHAR szVALID_SUFFIXES[] = "es ed ing s";
			// See if the entry should be included
			// For now, this just checks for entries with the phrase and common suffixes
			// or just the phrase itself.
			// NOTE: Some topic names start with a group number indicaotr, so this is ignored
			//		 Also, some have a sense indicator, which also must be ignored
			// TODO: find a better way of finding the right entries to include
			INT nPos = FindStringIgnoreCase(pszName, m_sPhrase);
			if (nPos != nINVALID_INDEX) {
				if ((nPos == 0)
					|| ((nPos == 1) && (IsDigit(pszName[0])))) {
					nPos += m_sPhrase.GetLength();
					CStringx sRem = ExtractToken(pszName, nPos, szLEFT_PAREN);
					sRem.TrimRight();
					if (sRem.IsEmpty()
						|| (FindStringIgnoreCase(szVALID_SUFFIXES, sRem) != nINVALID_INDEX)) {
						m_mapProcessed.SetAt(nTopic, TRUE);
						bProcess = TRUE;
						}
					}
				}
			}
		else {
			bProcess = (m_nNumKeyTopics != 100);
			}		

		//	Get the text from the topic if not already processed
		if (bProcess) {
			VA va = vaMVConvertAddr(m_hTitle, m_KeyAddrs[i]);
			::fMVSetAddress(m_pMvNonScrollable, va, nMV_NSR, 0, &m_err);
			::fMVSetAddress(m_pMvScrollable, va, nMV_SR, 0, &m_err);
			if (m_bAddSgml) {
				CString sNonScrollable;
				CString sScrollable;
				CopyTopicText(sNonScrollable, sScrollable);
				m_sResult += TopicTextToLookupSgml(sNonScrollable, sScrollable);
				}
			else {
#if FALSE
				CString sTopicSeparator;
				sTopicSeparator.Format("[%s]\r\n", pszName);
				m_sResult += sTopicSeparator;
#endif
				m_sResult += CopyTopicText();
				}
		}

		//	Free topic title string
		GlobalUnlock(hName);
		GlobalFree(hName);
	}

#if defined(_DEBUG)
	// Backdoor maneuvers out of an annoying assert
	if (FromHandlePermanent(m_hWnd) == NULL) {
		DEBUG_OUT(TL_VERBOSE, ("Window handle from map is NULL; detaching then re-attaching\n"));
		Detach();
		Attach(m_hWnd);
		}
	if (FromHandlePermanent(m_hWnd) != this) {
		DEBUG_OUT(TL_VERBOSE, ("Window handle from map (%x) != this (%x); detaching then attaching\n",
				  FromHandlePermanent(m_hWnd), this));
		Detach();
		Attach(m_hWnd);
		}
#endif

	UpdateData(bINITIALIZE);
}


// LookupCrossReferences: Return a list of topics that reference the current
// phrase. This is done by performing a full-text search (indexed of course)
//
VOID CMvLookupDlg::LookupCrossReferences (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDlg::LookupCrossReferences(): m_sPhrase=%s\n",
			  F(m_sPhrase)));
	ASSERT(m_hTitle != NULL);
	HANDLE hResultsTopicList;
	CString sSearch = m_sPhrase;

	// Put quotes around the search string if it contains embedded spaces
	// (without quotes) to ensure the words are not treated separately
	if ((m_sPhrase.Find(cSPACE) != nINVALID_INDEX)
		&& (m_sPhrase.Find(cDOUBLE_QUOTE) == nINVALID_INDEX)) {
		sSearch.Format("\"%s\"", (PCSZ)m_sPhrase);
	}
	m_sResult.Empty();

	// Do a full-text search on the topics for the phrase
	QUERYERR query_error;
	hResultsTopicList = hMVTopicListFromQuery(m_hTitle,
									   IMPLICIT_AND,
									   sSearch,
									   m_hTopicList,
									   0,		// use default for near
									   NULL,	// ignore higlight information
									   &query_error);

	// Add the name of each topic to the results buffer
	INT nNumTopics = ::lMVTopicListLength(hResultsTopicList);
	DEBUG_OUT(TL_VERBOSE, ("Search results:\n"));
	CString sName;
	for (INT i = 0; i < nNumTopics; ++i) {
		// Get the name from the topic file
		PSZ pszName = sName.GetBuffer(nMAX_NAME);
		INT nTopic = ::lMVTopicListLookup(hResultsTopicList, i);
		::lMVTitleGetInfo(m_hTitle, TTLINF_TOPICTITLE, nTopic, (LONG)pszName);
		sName.ReleaseBuffer();

		// Add it to the results buffer
		DEBUG_OUT(TL_VERBOSE, ("\t%s\n", (PCSZ)sName));
		if (!m_bAddSgml) {
			m_sResult += sName;
			m_sResult += cMV_ENTRY_SEP;
			m_sResult += cSPACE;
			}
		else {
			m_sResult += ReferenceToLookupSgml(sName);
			}
		}

	// Clean up the results list
	::MVTopicListDestroy(hResultsTopicList);
}


// CopyMediaText: Copy the text from the given MediaView object.
// This doesn't include any formatting indicators.
//
CString CMvLookupDlg::CopyMediaText (LPMV lpMV)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDlg::CopyMediaText(%x)\n", lpMV));
	CString sMediaText;
	HANDLE hMem = NULL;

	// Get a handle to a text block for the MediaView object
	m_err = wERRS_NONE;
	for (INT i = 0; i < 5; i++) {
		hMem = ::hMVCopyMedia(lpMV, &m_err);
		if (m_err != wERRS_PARTIAL) {
			break;
			}
		DEBUG_OUT(TL_DETAILED, ("Partial media copy; trying again after a nap\n"));
		Sleep(200);
		ASSERT(hMem);
		GlobalFree(hMem);
		}

	// Copy the text if accessible
	if (hMem) {
		PSZ pszMediaText = (PSZ)GlobalLock(hMem);
		ASSERT(pszMediaText);
		sMediaText = pszMediaText;
		GlobalUnlock(hMem);
		GlobalFree(hMem);
	}

	return (sMediaText);
}



// CopyTopicText: Copy the plain text from the current MediaView topic.
// This includes text from both the scrolling and nonscrolling regions.
//
VOID CMvLookupDlg::CopyTopicText (CString& sNonScrollable, CString& sScrollable)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDlg::CopyTopicText(%x, %x)\n",
			  &sNonScrollable, &sScrollable));

	// Copy both non-scrolling & scrolling regions
	sNonScrollable = CopyMediaText(m_pMvNonScrollable);
	sScrollable = CopyMediaText(m_pMvScrollable);
}


// CopyTopicText: Copy the plain text from the current MediaView topic.
// This version formats the nonscrollable region within angle brackets.
//
CString CMvLookupDlg::CopyTopicText (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDlg::CopyTopicText()\n"));
	CString sTopicText;

	// Copy both non-scrolling & scrolling regions
	CString sNonScrollable;
	CString sScrollable;
	CopyTopicText(sNonScrollable, sScrollable);
	sTopicText.Format("<%s>\r\n%s", (PCSZ)sNonScrollable, (PCSZ)sScrollable);

	return (sTopicText);
}


VOID CMvLookupDlg::OnCloseTitle (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDlg::OnCloseTitle()\n"));
	CloseTitle();
	m_comboGroups.ResetContent();
	m_comboKeywordGroups.ResetContent();
}


VOID CMvLookupDlg::OnOpenTitle (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDlg::OnOpenTitle()\n"));
	CONST CHAR szM14[] = "m14";
	CFileDialog dlg(TRUE, szM14);

	if (dlg.DoModal() == IDOK) {
		m_sTitle = dlg.GetPathName();
		OpenTitle();
	}
}


VOID CMvLookupDlg::OnOK (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDlg::OnOK()\n"));
	UpdateData(bSAVE_AND_VALIDATE);
	if (m_bKeySearch) {
		LookupPhrase();
	}
	else {
		LookupCrossReferences();
	}
	UpdateData(bINITIALIZE);
}


void CMvLookupDlg::OnSelchangeGroups() 
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDlg::OnSelchangeGroups()\n"));
	OpenTopicList();
}


void CMvLookupDlg::OnSelchangeKeywords() 
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDlg::OnSelchangeKeywords()\n"));
	OpenWordWheel();
}


void CMvLookupDlg::OnKeywordSearch() 
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDlg::OnKeywordSearch()\n"));

	m_bKeySearch = TRUE;
	EnableControls();
}


void CMvLookupDlg::OnFullTextSearch() 
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDlg::OnFullTextSearch()\n"));

	m_bKeySearch = FALSE;
	EnableControls();
}


VOID CMvLookupDlg::EnableControls (VOID) 
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDlg::EnableControls()\n"));

	BOOL bEnable = (m_hTitle != NULL);
	m_editResults.EnableWindow(bEnable);
	m_radioSearchType.EnableWindow(bEnable);
	m_comboKeywordGroups.EnableWindow(bEnable && m_bKeySearch);
	m_comboGroups.EnableWindow(bEnable && !m_bKeySearch);
}

void CMvLookupDlg::PostNcDestroy() 
{
	//CDialog::PostNcDestroy();
	delete this;
}

void CMvLookupDlg::OnCancel() 
{
	// The MFC documentation says that tor modeless dialog boxes you
	// don't call CDialog::OnCancel() but instead use DestroyWindow()
	DestroyWindow();
}
