// MvLookupDlg.h : header file
//

CONST INT nMV_NSR = 0;
CONST INT nMV_SR = 1;

/////////////////////////////////////////////////////////////////////////////
// CMvLookupDlg dialog

class CMvLookupDlg : public CDialog
{
//	DECLARE_DYNAMIC(CMvLookupDlg);
// Construction
public:
	CMvLookupDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CMvLookupDlg)
	enum { IDD = IDD_MVLOOKUP_DIALOG };
	CEdit	m_editResults;
	CButton	m_radioSearchType;
	CStatic	m_staticScrollable;
	CStatic	m_staticNonScrollable;
	CComboBox	m_comboGroups;
	CComboBox	m_comboKeywordGroups;
	CString	m_sPhrase;
	CString	m_sResult;
	BOOL	m_bAddSgml;
	//}}AFX_DATA
	BOOL m_bKeySearch;

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMvLookupDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual void PostNcDestroy();
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CMvLookupDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnCloseTitle();
	afx_msg void OnOpenTitle();
	virtual void OnOK();
	afx_msg void OnSelchangeGroups();
	afx_msg void OnSelchangeKeywords();
	afx_msg void OnKeywordSearch();
	afx_msg void OnFullTextSearch();
	afx_msg void OnDestroy();
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
	VOID InitMediaView (VOID);
	VOID CleanupMediaView (VOID);
	VOID OpenTitle (VOID);
	BOOL OpenTitle (CONST CString& sTitle);
	BOOL CloseTitle (VOID);
	BOOL OpenWordWheel (PCSZ pszWordWheel);
	VOID OpenWordWheel (VOID);
	VOID CloseWordWheel (VOID);
	BOOL OpenTopicList (PCSZ pszTopic);
	VOID OpenTopicList (VOID);
	VOID CloseTopicList (VOID);
	CString TopicTextToLookupSgml (CString& sNonScrollable, CString& sScrollable);
	CString ReferenceToLookupSgml (CString& sTopicName);
	VOID LookupPhrase (VOID);
	VOID LookupCrossReferences (VOID);
	CString CopyMediaText (LPMV lpMV);
	VOID CopyTopicText (CString& sNonScrollable, CString& sScrollable);
	CString CopyTopicText (VOID);
	VOID EnableControls (VOID);

	LPMV GetMediaView (VOID)	
		{ return (fMVHasSR(m_pMvScrollable) ? m_pMvScrollable : m_pMvNonScrollable); }
	VOID ForceInitDialog (VOID)			{ OnInitDialog(); }
public:
	CString m_sTitle;
	CStringArray m_sGroupName;
	HANDLE m_hTopicList;
	HANDLE m_hWordWheel;
	HTITLE m_hTitle;
	LPMV m_pMvNonScrollable;
	LPMV m_pMvScrollable;
	ERR m_err;
	INT m_nNumKeyTopics;
	CDWordArray m_KeyAddrs;
	CMap<INT, INT, INT, INT> m_mapProcessed;
	CStringArray m_asPartOfSpeech;
};


//MAKE_CLASS_CAST(CMvLookupDlg);
