// MvLookup.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "MvLookup.h"
#include "MvLookupDlg.h"

IMPLEMENT_DYNCREATE(CMvInfo, CWinThread);
IMPLEMENT_DYNAMIC(CMvLookup, CObject);

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMvLookupDll

BEGIN_MESSAGE_MAP(CMvLookupDll, CWinApp)
	//{{AFX_MSG_MAP(CMvLookupDll)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// The one and only CMvLookupDll object

CMvLookupDll theApp;
CWnd* pGlobalWndDummy = NULL;

/////////////////////////////////////////////////////////////////////////////
// CMvLookupDll construction

CMvLookupDll::CMvLookupDll(VOID)
{
	INIT_DEBUGGING_("MvLookup.ini");
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDll::CMvLookupDll\n"));
}


BOOL CMvLookupDll::InitInstance (VOID) 
{
	INIT_COMMON(AfxGetInstanceHandle(), NULL, "MvLookup");
	DEBUG_OUT(TL_VERBOSE, ("CMvLookupDll::InitInstance\n"));

	return CWinApp::InitInstance();
}



//-----------------------------------------------------------------------------
// CMvInfo
// 
// Interface class for accessing MediaView titles

#if FALSE
// NOTE: A single dialog is maintained to cut down on resources in MDI clients
//       such as Wordz.
//
CMvLookupDlg* pDlg = NULL;				// built-in dialog for doing lookups
HWND hDlg = NULL;						// handle for the build-in dialog


VOID InitMvLookup(CWnd* pMainFrame)
{
	DEBUG_OUT(TL_VERBOSE, ("InitMvLookup(%x)\n", pMainFrame));
	pDlg = new CMvLookupDlg(pWnd);
}

EXTERN VOID ShutdownMvLookup(VOID);
#endif


BOOL DoLock (CEvent& event, PCSZ pszName)
{
	DEBUG_OUT(TL_VERBOSE, ("DoLock(%x, %s)\n", &event, pszName));

	if (GetDebugOption("SkipLocks", TRUE)) {
		event.ResetEvent();
		Sleep(100);	// sleep 1/10th of a second so the other guy becomes active
		return (TRUE);
		}

	// Wait to access the event/lock
	CSingleLock lock(&event);
	DWORD dwResult = lock.Lock(INFINITE);
	if (dwResult == 0) {
		DEBUG_OUT(TL_BASIC, ("Problem waiting for event %s\n", pszName));
		return (FALSE);
		}
	event.ResetEvent();

	return (TRUE);
}

#define DO_LOCK(event)		DoLock(event, #event);


//-----------------------------------------------------------------------------
// CMvInfo
// 
// Interface class for accessing MediaView titles

#if FALSE
CMvInfo::CMvInfo (CWnd* pParentWnd, PCSZ pszTitle)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::CMvInfo(%x, %s)\n", pParentWnd, F(pszTitle)));

	m_hWndParent = pParentWnd ? pParentWnd->m_hWnd : NULL;
	m_sTitle = pszTitle;
	AfxThreadBegin();
	UNREFERENCED_PARAMETER(pszTitle);
}
#endif


CMvInfo::CMvInfo (VOID)
	: m_eventLookup(TRUE, TRUE),		// lock this initially; manual reset
	m_eventResults(TRUE, TRUE),			// and this; likewise, manual reset
	m_eventLookupPhrase(FALSE, TRUE),	// but not this; likewise, manual reset
	m_eventLookupReferences(FALSE, TRUE), // ditto; likewise, manual reset
	m_eventOpenTitle(FALSE, TRUE),		// ditto; likewise, manual reset
	m_eventCloseTitle(FALSE, TRUE),		// ditto; likewise, manual reset
	m_eventOpenWordWheel(FALSE, TRUE),	// ditto; likewise, manual reset
	m_eventOpenTopicList(FALSE, TRUE)	// ditto; likewise, manual reset
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::CMvInfo()\n"));
	m_pDlg = NULL;
	Init();
}


CMvInfo::~CMvInfo (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::~CMvInfo()\n"));

#if FALSE
	CMvLookupDlg* pDlg = GetLookupDialog();
	if (pDlg && IsWindow(pDlg->m_hWnd)) {
		pDlg->DestroyWindow();
		pDlg = NULL;
	}
#endif

#if TRUE
	if (pGlobalWndDummy) {
		delete pGlobalWndDummy;
		}
#endif
}


BOOL CMvInfo::InitInstance (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::InitInstance()\n"));

	//Init();
	LookupWorker();
	return (TRUE);
}


BOOL CMvInfo::Init (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::Init()\n"));

	//CWnd* pParentWnd = CWnd::FromHandle(m_hParentWnd);
	//CMvLookupDlg* pDlg = new CMvLookupDlg(pParentWnd);
	m_pDlg = new CMvLookupDlg(NULL);

	HINSTANCE hInst = theApp.m_hInstance;
	HRSRC hResource = ::FindResource(hInst, MAKEINTRESOURCE(IDD_MVLOOKUP_DIALOG), RT_DIALOG);
	HGLOBAL hTemplate = LoadResource(hInst, hResource);
	//BOOL bCreatedOK = pDlg->CreateIndirect(hTemplate, pParentWnd);
	BOOL bCreatedOK = m_pDlg->CreateIndirect(hTemplate, NULL);
	ASSERT(bCreatedOK);
	FreeResource(hTemplate);
	m_pDlg->ShowWindow(SW_HIDE);
	m_hDlg = m_pDlg->m_hWnd;
	ASSERT(m_hDlg);
	SET_APP_WINDOW(hInst, m_hDlg);

#if FALSE
	if (pDlg->m_pMvNonScrollable == NULL) {
		pDlg->ForceInitDialog();
		}
#endif

#if TRUE
	if (!m_sTitle.IsEmpty()) {
		m_pDlg->OpenTitle(m_sTitle);
		}
#endif


#if FALSE
	// Try to force map usage in this thread to overcome problem w/ dlg
	// not being mapped problem and failing an AssertValid call during a lookup
	pGlobalWndDummy = CWnd::FromHandlePermanent(m_hDlg);
	CWnd* pLocalWndDummy =  CWnd::FromHandle(m_hDlg);
#endif


	// Release the lock which is initially set
	// Also, release some of the others while we're at it
	m_eventLookup.SetEvent();
	m_eventResults.SetEvent();

	//LookupWorker();

	return (TRUE);
}


BOOL CMvInfo::ExitInstance (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::ExitInstance()\n"));

	CWnd* pDlg = CWnd::FromHandle(m_hDlg);
	if (pDlg) {
		pDlg->DestroyWindow();
		}

	return (TRUE);
}


// OpenTitle: Open a MediaView title
//
BOOL CMvInfo::OpenTitle (PCSZ pszTitle)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::OpenTitle('%s')\n", F(pszTitle)));

	CMvLookupDlg* pDlg = GetLookupDialog();
	BOOL bOK = pDlg && pDlg->OpenTitle(pszTitle);

	return (bOK);
}


BOOL CMvInfo::MtOpenTitle (PCSZ pszTitle)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::MtOpenTitle('%s')\n", F(pszTitle)));

	// Wait for the event coordination lock
	DO_LOCK(m_eventLookup);

	// Set the name and signal that an open title event is desired
	m_sTitle = pszTitle;
	m_eventOpenTitle.SetEvent();

	// Wait for the results coordination lock
	DO_LOCK(m_eventResults);

	// Access the results and signal that it is available
	BOOL bOK = m_bOK;
	m_eventResults.ResetEvent();

	return (bOK);
}


// OpenTitle: Close the MediaView title
//
BOOL CMvInfo::CloseTitle (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::CloseTitle()\n"));

	CMvLookupDlg* pDlg = GetLookupDialog();
	BOOL bOK = pDlg && pDlg->CloseTitle();

	return (bOK);
}


BOOL CMvInfo::MtCloseTitle (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::MtCloseTitle()\n"));

	// Wait for the event coordination lock
	DO_LOCK(m_eventLookup);

	// Signal that an close title event is desired
	m_eventCloseTitle.SetEvent();

	// Wait for the results coordination lock
	DO_LOCK(m_eventResults);

	// Access the results and signal that it is available
	BOOL bOK = m_bOK;
	m_eventResults.ResetEvent();

	return (bOK);
}

// OpenWordWheel: Open the MediaView wordwheel with the given name
// Wordwheels are used for doing keyword lookup
//
BOOL CMvInfo::OpenWordWheel (PCSZ pszName)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::OpenWordWheel(%s)\n", F(pszName)));

	CMvLookupDlg* pDlg = GetLookupDialog();
	BOOL bOK = pDlg && pDlg->OpenWordWheel(pszName);

	return (bOK);
}


BOOL CMvInfo::MtOpenWordWheel (PCSZ pszName)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::MtOpenWordWheel(%s)\n", F(pszName)));

	// Wait for the event coordination lock
	DO_LOCK(m_eventLookup);

	// Set the name and signal that an open word wheel event is desired
	m_sWordWheel = pszName;
	m_eventOpenWordWheel.SetEvent();

	// Wait for the results coordination lock
	DO_LOCK(m_eventResults);

	// Access the results and signal that it is available
	BOOL bOK = m_bOK;
	m_eventResults.ResetEvent();

	return (bOK);
}


// OpenTopicList: Open the MediaView topic list with the given name
// Topic lists are used for doing full-text search (for cross-references)
//
BOOL CMvInfo::OpenTopicList (PCSZ pszName)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::OpenTopicList(%s)\n", F(pszName)));

	CMvLookupDlg* pDlg = GetLookupDialog();
	BOOL bOK = pDlg && pDlg->OpenTopicList(pszName);

	return (bOK);
}


// OpenTopicList: Open the MediaView topic list with the given name
// Topic lists are used for doing full-text search (for cross-references)
//
BOOL CMvInfo::MtOpenTopicList (PCSZ pszName)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::MtOpenTopicList(%s)\n", F(pszName)));

	// Wait for the event coordination lock
	DO_LOCK(m_eventLookup);

	// Set the name and signal that an open topic list event is desired
	m_sTopicList = pszName;
	m_eventOpenTopicList.SetEvent();

	// Wait for the results coordination lock
	DO_LOCK(m_eventResults);

	// Access the results and signal that it is available
	BOOL bOK = m_bOK;
	m_eventResults.ResetEvent();

	return (bOK);
}


// DoLookupDialog: Invoke the built-in lookup dialog
// This just activates the dialog since it is shamelessly used anyway.
//
// NOTE: This really shouldn't be used in a multithreaded application
//
CWnd* CMvInfo::DoLookupDialog (CWnd* pParentWnd)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::DoLookupDialog(%x)\n", pParentWnd));
	UNREFERENCED_PARAMETER(pParentWnd);

	CMvLookupDlg* pDlg = GetLookupDialog();
	if (pDlg) {
		pDlg->ShowWindow(SW_SHOW);
		pDlg->SetFocus();
		pDlg->EnableControls();
		}

	return (pDlg);
}


// LookupWorker: Workhorse routine for waiting upon lookup requests
//
VOID CMvInfo::LookupWorker (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::LookupWorker()\n"));

	// Create an multiple-event lock for the lookup request events
	CEvent* apEvents[] = { &m_eventLookupPhrase,
						   &m_eventLookupReferences,
						   &m_eventOpenTitle,
						   &m_eventCloseTitle,
						   &m_eventOpenWordWheel,
						   &m_eventOpenTopicList };
	enum LookupEvents { e_LookupPhrase = WAIT_OBJECT_0, e_LookupReferences, e_OpenTitle, 
						e_CloseTitle, e_OpenWordWheel, e_OpenTopicList };
	CONST PCSZ apszLookupEvents[] = { "N/A", "e_LookupPhrase", "e_LookupReferences", "e_OpenTitle", 
						"e_CloseTitle", "e_OpenWordWheel", "e_OpenTopicList", "ERROR" };

	CMultiLock locks((CSyncObject**)apEvents, 6);

	for (;;) {
		DEBUG_OUT(TL_VERBOSE, ("LookupWorker waiting for work\n"));

		// Wait for the next request
		DWORD dwWaitResult = locks.Lock(INFINITE, FALSE); // wait forever for one of the events

		DEBUG_OUT(TL_VERBOSE, ("LookupWorker servicing event %s\n",
				  apszLookupEvents[max(0, min(NUM_ELEMENTS(apszLookupEvents) - 1, 
											  dwWaitResult - WAIT_OBJECT_0 + 1))]));
		switch (dwWaitResult) {
			case e_LookupPhrase:
				m_eventLookupPhrase.ResetEvent();
				m_sResults = LookupPhrase(m_sPhrase);
				break;
			case e_LookupReferences:
				m_eventLookupReferences.ResetEvent();
				m_sResults = LookupCrossReferences(m_sPhrase);
				break;
			case e_OpenTitle:
				m_eventOpenTitle.ResetEvent();
				m_bOK = OpenTitle(m_sTitle);
				break;
			case e_CloseTitle:
				m_eventCloseTitle.ResetEvent();
				m_bOK = CloseTitle();
				break;
			case e_OpenWordWheel:
				m_eventOpenWordWheel.ResetEvent();
				m_bOK = OpenWordWheel(m_sWordWheel);
				break;
			case e_OpenTopicList:
				m_eventOpenTopicList.ResetEvent();
				m_bOK = OpenTopicList(m_sTopicList);
				break;
			default:
				DEBUG_OUT(TL_BASIC, ("Problem waiting for MvLookup events (result=%lu)\n", dwWaitResult));
				break;
			}
		m_eventLookup.SetEvent();
		m_eventResults.SetEvent();
		}
}


// MtLookupPhrase: Lookup the topics in the database given a phrase keyword
//
CString CMvInfo::MtLookupPhrase (PCSZ pszPhrase)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::MtLookupPhrase(%s)\n", F(pszPhrase)));
	CString sResult;

	DO_LOCK(m_eventLookup);

	// Set the phrase and signal that a definition lookup is desired
	m_sPhrase = pszPhrase;
	m_eventLookupPhrase.SetEvent();

	DO_LOCK(m_eventResults);

	// Access the results and signal that it is available
	sResult = m_sResults;
	m_eventResults.ResetEvent();

	return (sResult);
}


// MtLookupReferences: Lookup the topics in the database given a phrase keyword
//
CString CMvInfo::MtLookupCrossReferences (PCSZ pszReferences)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::MtLookupCrossReferences (%s)\n", F(pszReferences)));
	CString sResult;

	// Wait to access the phrase
	CSingleLock lockLookup(&m_eventLookup);
	DWORD dwResult = lockLookup.Lock(INFINITE);
	m_eventLookup.ResetEvent();
	if (dwResult == 0) {
		DEBUG_OUT(TL_BASIC, ("Problem waiting for m_eventLookup\n"));
		return (sResult);
		}

	// Set the phrase and signal that a cross reference lookup is desired
	m_sPhrase = pszReferences;
	m_eventLookupReferences.SetEvent();

	// Wait to access the results
	CSingleLock lockResults(&m_eventResults);
	lockResults.Lock(INFINITE);
	m_eventResults.ResetEvent();
	if (dwResult == 0) {
		DEBUG_OUT(TL_BASIC, ("Problem waiting for m_eventResults\n"));
		return (sResult);
		}

	// Access the results and signal that it is available
	sResult = m_sResults;
	m_eventResults.SetEvent();

	return (sResult);
}


// LookupPhrase: Lookup the topics in the database given a phrase keyword
//
CString CMvInfo::LookupPhrase (PCSZ pszPhrase)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::LookupPhrase(%s)\n", F(pszPhrase)));
	CString sResults;

	CMvLookupDlg* pDlg = GetLookupDialog();
	if (pDlg) {
		pDlg->m_sPhrase = pszPhrase;
		pDlg->LookupPhrase();
		sResults = pDlg->m_sResult;
		}

	return (sResults);
}


// LookupCrossReferences: Lookup the topics that contain a given phrase
//
CString CMvInfo::LookupCrossReferences (PCSZ pszPhrase)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::LookupCrossReferences(%s)\n", F(pszPhrase)));
	CString sResult;

	CMvLookupDlg* pDlg = GetLookupDialog();
	if (pDlg) {
		pDlg->m_sPhrase = pszPhrase;
		pDlg->LookupCrossReferences();
		sResult = pDlg->m_sResult;
		}

	return (sResult);
}


// GetLookupDialog: Return a temporary pointer to the MvLookup dialog
//
CMvLookupDlg* CMvInfo::GetLookupDialog (VOID)
{
#if FALSE
	DEBUG_OUT(TL_VERBOSE, ("CMvInfo::GetLookupDialog()\n"));
	//CMvLookupDlg* pDlg = ToCMvLookupDlg(CWnd::FromHandlePermanent(m_hDlg));
	CMvLookupDlg* pDlg = (CMvLookupDlg*)(CWnd::FromHandlePermanent(m_hDlg));
	//CMvLookupDlg* pDlg = (CMvLookupDlg*)(CWnd::FromHandle(m_hDlg));
	ASSERT(pDlg);

	return (pDlg);
#endif

	return (m_pDlg);
}



BOOL CMvInfo::IsValid (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookup::IsValid()\n"));

	return (IsKindOf(RUNTIME_CLASS(CMvLookup)));
}


//-----------------------------------------------------------------------------
// CMvLookup
// 
// Interface class for actual lookup's


CMvLookup::CMvLookup (CMvInfo* pMvInfo)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookup::CMvLookup(%x)\n", 
							ToCMvInfo(pMvInfo)));
	m_pMvInfo = pMvInfo;
	m_bAddSgml = TRUE;
}


CMvLookup::~CMvLookup (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookup::~CMvLookup()\n"));
}


// LookupPhrase: Lookup the topics in the database given a phrase keyword
//
CString CMvLookup::LookupPhrase (PCSZ pszPhrase)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookup::LookupPhrase(%s)\n", F(pszPhrase)));
	CString sResult;
	ASSERT_VALID(m_pMvInfo);

	CMvLookupDlg* pDlg = m_pMvInfo ? m_pMvInfo->GetLookupDialog() : NULL;
	if (pDlg) {
		pDlg->m_sPhrase = pszPhrase;
		pDlg->LookupPhrase();
		sResult = pDlg->m_sResult;
		}

	return (sResult);
}


CString CMvLookup::MtLookupPhrase (PCSZ pszPhrase)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookup::MtLookupPhrase(%s)\n", F(pszPhrase)));
	CString sResult;
	ASSERT_VALID(m_pMvInfo);

	if (m_pMvInfo) {
		sResult = m_pMvInfo->MtLookupPhrase(pszPhrase);
		}

	return (sResult);
}


// LookupCrossReferences: Lookup the topics that contain a given phrase
//
CString CMvLookup::LookupCrossReferences (PCSZ pszPhrase)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookup::LookupCrossReferences(%s)\n", F(pszPhrase)));
	CString sResult;
	ASSERT_VALID(m_pMvInfo);

	CMvLookupDlg* pDlg = m_pMvInfo ? m_pMvInfo->GetLookupDialog() : NULL;
	if (pDlg) {
		pDlg->m_sPhrase = pszPhrase;
		pDlg->LookupCrossReferences();
		sResult = pDlg->m_sResult;
		}

	return (sResult);
}


CString CMvLookup::MtLookupCrossReferences (PCSZ pszPhrase)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookup::MtLookupCrossReferences(%s)\n", F(pszPhrase)));
	CString sResult;
	ASSERT_VALID(m_pMvInfo);

	if (m_pMvInfo) {
		sResult = m_pMvInfo->MtLookupCrossReferences(pszPhrase);
		}

	return (sResult);
}


// UseSgml: Indicate whether the results should be formatted with (pseudo) SGML
//
VOID CMvLookup::UseSgml (BOOL bUseSgml /* = TRUE */)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookup::UseSgml(%d)\n", bUseSgml));
	ASSERT_VALID(m_pMvInfo);

	CMvLookupDlg* pDlg = m_pMvInfo ? m_pMvInfo->GetLookupDialog() : NULL;
	if (pDlg) {
		pDlg->m_bAddSgml = bUseSgml;
		}
}


BOOL CMvLookup::IsValid (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvLookup::IsValid()\n"));

	return (IsKindOf(RUNTIME_CLASS(CMvLookup)));
}


//-----------------------------------------------------------------------------
// Interface functions


// InitMvInfo: Creates a thread with CMvInfo and returns the object pointer
//

//CMvInfo* InitMvInfo (CWnd* pWnd, PCSZ pszTitle)

CMvInfo* CreateMvInfo (VOID)
{
	CMvInfo* pMvInfo = (CMvInfo*)AfxBeginThread(RUNTIME_CLASS(CMvInfo));
	if (pMvInfo) {
		//HWND hWndParent = pWnd ? pWnd->m_hWnd : NULL;
		//pMvInfo->Init(hWndParent, pszTitle);
		//pMvInfo->Init();
		}

	return (pMvInfo);
}

