// CMvMain.cpp : implementation file
//

#include "stdafx.h"
#include "MvLookupApp.h"
#include "MvInfo.h"
#include "MvMain.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMvMain dialog


CMvMain::CMvMain(CWnd* pParent /*=NULL*/)
	: CDialog(CMvMain::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMvMain)
	m_sPhrase = _T("");
	m_sResult = _T("");
	m_bXrefs = FALSE;
	m_sTopic = _T("Dictionary");
	m_sWordWheel = _T("Dictionary");
	m_sTitle = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bXrefs = FALSE;
}

CMvMain::~CMvMain(VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvMain::~CMvMain()\n"));

	if (m_pMvInfo && m_pMvInfo->IsValid()) {
		delete m_pMvInfo;
		m_pMvInfo = NULL;
	}
	if (m_pMvLookup && m_pMvLookup->IsValid()) {
		delete m_pMvLookup;
		m_pMvLookup = NULL;
	}
}


BOOL CMvMain::InitMediaView (VOID)
{
	// Get the file name of the title (default to Bookshelf)
	m_sTitle = AfxGetApp()->m_lpCmdLine;
#if FALSE
	if (m_sTitle.IsEmpty()) {
		m_sTitle = "g:\\books\\Bshelf95.m14";
	}
#endif
	m_pMvInfo = new CMvInfo();
	m_pMvLookup = new CMvLookup(m_pMvInfo);
	if (!m_pMvInfo || !m_pMvLookup) {
		AfxMessageBox("Unable to initialize MediaView lookup (MvLookup.dll)");
		return (FALSE);
		}

	if (!m_sTitle.IsEmpty()) {
		UpdateData(FALSE);
		m_pMvInfo->MtOpenTitle(m_sTitle);
		m_pMvInfo->MtOpenWordWheel(m_sWordWheel);
		m_pMvInfo->MtOpenTopicList(m_sTopic);
	}

	return (TRUE);
}

void CMvMain::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMvMain)
	DDX_Text(pDX, IDC_PHRASE, m_sPhrase);
	DDX_Text(pDX, IDC_RESULTS, m_sResult);
	DDX_Check(pDX, IDC_CROSS_REFS, m_bXrefs);
	DDX_Text(pDX, IDC_TOPIC, m_sTopic);
	DDX_Text(pDX, IDC_WORD_WHELL, m_sWordWheel);
	DDX_Text(pDX, IDC_TITLE, m_sTitle);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMvMain, CDialog)
	//{{AFX_MSG_MAP(CMvMain)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_EN_CHANGE(IDC_PHRASE, OnChangePhrase)
	ON_BN_CLICKED(IDC_QUERY, OnQuery)
	ON_EN_KILLFOCUS(IDC_TOPIC, OnKillfocusTopic)
	ON_EN_KILLFOCUS(IDC_WORD_WHELL, OnKillfocusWordWhell)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMvMain message handlers


/////////////////////////////////////////////////////////////////////////////
// CMvMain message handlers

BOOL CMvMain::OnInitDialog()
{
	DEBUG_OUT(TL_VERBOSE, ("CMvMain::OnInitDialog()\n"));

	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Initialize the subdialog that does all the work
#if FALSE
	m_pLookupDlg = new CMvLookupDlg(this);
	BOOL bOK = m_pLookupDlg->Create(IDD_MVLOOKUP_DIALOG);
	if (bOK) {
		CRect rect;
		GetClientRect(rect);
		m_pLookupDlg->MoveWindow(rect);

		// Get the file name of the title (default to Bookshelf)
		CString sTitle = AfxGetApp()->m_lpCmdLine;
		if (sTitle.IsEmpty()) {
			sTitle = "g:\\books\\Bshelf95.m14";
		}
		bOK = bOK && m_pLookupDlg->OpenTitle(sTitle);
	}
#endif

	InitMediaView();

	return TRUE;  // return TRUE  unless you set the focus to a control
}


void CMvMain::OnSysCommand(UINT nID, LPARAM lParam)
{
	DEBUG_OUT(TL_VERBOSE, ("CMvMain::OnSysCommand(%d, %x)\n",
			  nID, lParam));

	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}


// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMvMain::OnPaint() 
{
	DEBUG_OUT(TL_VERBOSE, ("CMvMain::OnPaint()\n"));

	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}


// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMvMain::OnQueryDragIcon()
{
	DEBUG_OUT(TL_VERBOSE, ("CMvMain::OnQueryDragIcon()\n"));

	return (HCURSOR) m_hIcon;
}


VOID CMvMain::OnDestroy() 
{
	DEBUG_OUT(TL_VERBOSE, ("CMvMain::OnDestroy()\n"));

	CDialog::OnDestroy();
}


void CMvMain::OnChangePhrase() 
{
	DEBUG_OUT(TL_GARRULOUS, ("CMvMain::OnChangePhrase()\n"));
}


void CMvMain::OnQuery() 
{
	DEBUG_OUT(TL_VERBOSE, ("CMvMain::OnQuery()\n"));
	
	UpdateData(TRUE);	// retrieve data
	if (m_bXrefs) {
		m_sResult = m_pMvLookup->LookupCrossReferences(m_sPhrase);
	}
	else {
		m_sResult = m_pMvLookup->LookupPhrase(m_sPhrase);
	}
	UpdateData(FALSE);	// re-initialize
}


void CMvMain::OnOK() 
{
	DEBUG_OUT(TL_VERBOSE, ("CMvMain::OnOK()\n"));

	OnQuery();	
}


void CMvMain::OnKillfocusTopic(VOID) 
{
	DEBUG_OUT(TL_VERBOSE, ("CMvMain::OnKillfocusTopic()\n"));

	m_pMvInfo->MtOpenTopicList(m_sTopic);
}


void CMvMain::OnKillfocusWordWhell(VOID) 
{
	DEBUG_OUT(TL_VERBOSE, ("CMvMain::OnKillfocusWordWhell()\n"));

	m_pMvInfo->MtOpenWordWheel(m_sWordWheel);
}


void CMvMain::OnBrowse() 
{
	DEBUG_OUT(TL_VERBOSE, ("CMvMain::OnBrowse()\n"));

	CFileDialog	dlgOpenFile(TRUE);
	if (dlgOpenFile.DoModal() == IDOK) {
		m_sTitle = dlgOpenFile.GetPathName();
		UpdateData(FALSE);
		m_pMvInfo->MtOpenTitle(m_sTitle);
		m_pMvInfo->MtOpenWordWheel(m_sWordWheel);
		m_pMvInfo->MtOpenTopicList(m_sTopic);
		}
}
