// parseman.h : header file
//


/////////////////////////////////////////////////////////////////////////////
// CParseManager command target

class CParseManager : public CCmdTarget
{   
	DECLARE_SERIAL(CParseManager)
protected:
	CParseManager();			// protected constructor used by dynamic creation
public:
	CParseManager(CONST CString& lexicon, CONST CString& graph);

// Attributes
public:
	OpenLexicon (CONST CString& filename);
	OpenGraph (CONST CString& filename);

// Operations
public:
	//	Parse a text phrase
	BOOL Parse (CONST CString& text)	{ return (StartParse("START", &text)); }
protected:
	//	Worker function for doing the actual parsing
	BOOL StartParse (CONST CString& node, CONST CString* pText /* = NULL */);
	BOOL ParseIt (CONST CString& node, CONST CString* pText /* = NULL */);

// Implementation
public:
	virtual ~CParseManager();
	virtual VOID Serialize (CArchive& ar);
#if defined(_DEBUG)
	virtual VOID AssertValid (VOID) const;
	virtual VOID Dump (CDumpContext& dc) const;
#endif

protected:
	// Generated message map functions
	//{{AFX_MSG(CParseManager)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	CCaseFrame* m_pCF;
	CLexicon* m_plex;
	CGraph* m_pgraph;
};

MAKE_CLASS_CAST(CParseManager)

/////////////////////////////////////////////////////////////////////////////
