#if !defined(_PHRASE_H)
#define _PHRASE_H

#ifdef __cplusplus
extern "C" {
#endif

INT 	GetKey 			(PSZ pszKey, INT nMaxChars, PCSZ pszPhrase, BOOL bStrict);
INT 	PhraseCompare 	(PCSZ pszPhrase1, PCSZ pszPhrase2, BOOL bStrict);

CONST CHAR szIGNORE_INDEXING[] = "-, .";
CONST CHAR szIGNORE_SEARCHING[] = "-, .{";

inline BOOL IgnoreChar (CHAR c, BOOL bStrict)
{
	return ((c == '-') || (c == ',') || (c == ' ') || (c == '.')
			|| (!bStrict && (c == '\'')));
	// || (c == '{') || (c == '}));	--don't include since this would affect search
	// || (c == '\'')); --don't include since DICT1 requires distinction
}

inline BOOL EndOfPhrase (PCSZ pszPhrase)
{
//	return ((*pszPhrase == '\0') || (*pszPhrase == '{'));
	return (*pszPhrase == '\0');
}

inline INT PhraseEQ (PCSZ pszPhrase1, PCSZ pszPhrase2, BOOL bStrict)
{
	return (PhraseCompare(pszPhrase1, pszPhrase2, bStrict) == 0);
}

inline INT PhraseGT (PCSZ pszPhrase1, PCSZ pszPhrase2, BOOL bStrict)
{
	return (PhraseCompare(pszPhrase1, pszPhrase2, bStrict) > 0);
}

#ifdef __cplusplus
}
#endif

#endif	// !defined(_PHRASE_H)
