#if !defined(_COMMON_)

#define _COMMON_ 
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <dos.h>
#include <time.h>
#include <limits.h>
#include <io.h>

// definition of basic types
#define CONST const
#define STATIC static
typedef void		VOID, *PVOID;
typedef int INT, *PINT;
typedef INT BOOL, *PBOOL;
typedef unsigned short WORD, FLAGS;
typedef long LONG, *PLONG;
typedef char CHAR, *PCHAR, *PSTR, **PPSTR;
typedef unsigned char BYTE, *PBYTE;
typedef FILE *PFILE;

inline INT min(INT n, INT m) { return ( (n < m) ? n : m ); }
inline INT max(INT n, INT m) { return ( (n > m) ? n : m ); }
inline LONG min(LONG n, LONG m) { return ( (n < m) ? n : m ); }
inline LONG max(LONG n, LONG m) { return ( (n > m) ? n : m ); }

#ifdef __cplusplus
extern "C" {
#endif

// Global macros
#define EQUAL_STR(STR1, STR2)   (!strcmp((STR1), (STR2)))
#define CHAR_LOC(STR1, CHAR1)   (strchr((STR1), (CHAR1)))
#define STR_LOC(STR1, STR2)     (strstr((STR1), (STR2)))
#define NUM_ELEMENTS(array)		(sizeof(array) / sizeof(array[0]))
#define NUM_CHARS(string)		(NUM_ELEMENTS(string))
#define STRING_SIZE(string)		(NUM_CHARS(string) - 1)
#define MAX_CHARS(string)		(STRING_SIZE(string))

// Global constants
#define TRUE 		(1)
#define FALSE 		(0)
#define SPACE 		(' ')
#define NULL_CHAR 	('\0')
#define PATH_MAX 	(256)
CONST CHAR cNULL = 	NULL_CHAR;

//	conversion table
//
typedef struct {
	INT nCode;
	PSTR pszString;
	} CODEC, *PCODEC;
	
inline VOID MakeUpper (PSTR psz)
{
	while (*psz) {
		*psz = (CHAR)toupper(*psz);
		psz++;
		}
}


PFILE	OpenFile (PSTR pszFileName, PSTR pszFileMode, PFILE hFile, PFILE hDefaultFile, BOOL bExitOnFailure);
PFILE   OpenDirFile (PSTR pszDir, PSTR pszFileName, PSTR pszFileMode, PFILE hFile, PFILE hDefaultFile, BOOL bExitOnFailure);
PFILE 	CloseFile (PFILE hFile,  PFILE hDefaultFile);
BOOL	RemoveDirFile (PSTR pszDir, PSTR pszFileName);
INT		ReadData (PVOID pData, INT nSize, INT nNumToRead, PFILE hFile);
INT 	GetString (PFILE hFile, PSTR pszBuffer, INT nMaxLen);
BOOL	WriteText (PFILE hFile, PSTR pszFormat, ...);
LONG	GetFilePos (PFILE hFile);
BOOL	SetFilePos (PFILE hFile, LONG lOffset, INT nFromWhere);
LONG	MyGetFileSize (PFILE hFile);
VOID 	_ReportAssertion (PSTR pszExpr, PSTR pszFile, INT nLine);
VOID 	_ReportError (PSTR pszExpr, PSTR pszFile, INT nLine);
BOOL 	DisplayAvailMem (VOID);
INT		StringToCode (PCODEC pCodeTable, INT nSize, PSTR pszString);
PSTR	CodeToString (PCODEC pCodeTable, INT nSize, INT nCode);


//	Support for debugging
#if defined(_DEBUG)
extern PFILE hTrace;                    // file for diagnostics
#endif

inline VOID TraceOut (PSTR pszFormat, ...)
{
#ifdef _DEBUG
	if (hTrace) {
		va_list vaArgs;
		va_start (vaArgs, pszFormat);
		vfprintf(hTrace, pszFormat, vaArgs);
		va_end (vaArgs);	
		}
#endif
}

#if defined(_DEBUG)
#define Assert(exp)	\
	if (!(exp)) { \
		_ReportAssertion(#exp, __FILE__, __LINE__); \
		}
#else
#define Assert(exp)
#endif

//	what to do if all else fails
//
#define FatalAssert(exp) \
	if (!(exp)) { \
		_ReportError(#exp, __FILE__, __LINE__); \
		}

//	Inline function wrappers
//

inline CHAR ToUpper (CHAR ch)
{
	return ((CHAR)toupper(ch));
}

#ifdef __cplusplus
}
#endif

#if defined(_DEBUG)
#pragma warning (disable : 4505)
#endif

#endif
