#include "commonxx.h"
#include "lookup.h"

//	Constants
//
CONST CHAR szAPP_NAME[] = 	"TESTIT";
CONST CHAR szTESTIT_INI[] =	"LOOKUP.INI";
#define WHITE               (RGB(255,255,255))
CONST INT nDEFAULT_FONT_SIZE =	16;
CONST CHAR szMISC[] =		"MISC";
CONST CHAR szFONT_SIZE[] =	"FontSize";
CONST CHAR szFONT_NAME[] =	"FontName";
#define ARIAL				"Arial"
CONST CHAR szARIAL[] = 		ARIAL;

//  Application global variables
//
HWND  hAppWnd = NULL;
HANDLE hAppInst = NULL;
HANDLE hPrevAppInst = NULL;
PLOOKUP_INFO pLI = NULL;
CHAR szPhrase[80] = "stupid";
PCSZ pszResult = "";
INT nResultLen = 0;
INT nFontSize = nDEFAULT_FONT_SIZE;
CHAR szFontName[80] = ARIAL;

//	Function prototypes
//
INT PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpszCmdLine, INT nCmdShow);
BOOL InitApp (HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpszCmdLine, INT nCmdShow);
BOOL StopApp (INT nErrorCode);
BOOL TermApp (VOID);
BOOL ParseCmdLine (PCSZ pszCmdLine);
LONG FAR APIENTRY WndProc (HWND hwnd, UINT message, UINT wParam, LONG lParam);
BOOL UpdateDisplay (HWND hwnd, HDC hdc);



INT PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpszCmdLine, INT nCmdShow)
{
	DEBUG_OUT(TL_ALWAYS, ("WinMain(%x,%x,'%s',%d)\n", 
						  hInstance, hPrevInstance, lpszCmdLine, nCmdShow));

	BOOL bOK = InitApp(hInstance, hPrevInstance, lpszCmdLine, nCmdShow);
	if (!bOK) {
		DEBUG_OUT(TL_BASIC, ("Initialization of application failed"));
		StopApp(1);
		}

	PBYTE pMem = NULL;
	pMem = (PBYTE)lpszCmdLine;
	DEBUG_OUTF(TL_ALWAYS, ("sizeof(pMem) = %d; pMem = %lx; pMem -> %s\n",
							sizeof(pMem), pMem, pMem));
	
	// Process the message queue
	MSG msg;
	BOOL bMoreMsgs = TRUE;
	while (bMoreMsgs) {
		if (IsMessageLoopPaused()) {
			WaitMessage();
			continue;
			}
		bMoreMsgs = GetMessage (&msg, NULL, 0, 0);
		if (bMoreMsgs) {		
			if (IsAppActive()) {
				TranslateMessage (&msg);
				DispatchMessage (&msg);
				}
			else {
	        	DEBUG_OUT(TL_BASIC, ("Ignoring message %u since app inactive\n", msg.message));
				}
			}
		}
	
	TermApp();
	
	return (msg.wParam);
}



BOOL InitApp (HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpszCmdLine, INT nCmdShow)
{
	hAppInst = hInstance;
	hPrevAppInst = hPrevInstance;

	InitCommon(szAPP_NAME);		
	INIT_DEBUGGING();
	DEBUG_OUT(TL_VERBOSE, ("InitApp(%x,%x,'%s',%d)\n", 
						   hInstance, hPrevInstance, lpszCmdLine, nCmdShow));
	ParseCmdLine(lpszCmdLine);

	// Register the window class (if not already registered)
	WNDCLASS    wndclass;
	if (!hPrevAppInst) {
		 wndclass.style         = CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
		 wndclass.lpfnWndProc   = WndProc;
		 wndclass.cbClsExtra    = 0;
		 wndclass.cbWndExtra    = 0;
		 wndclass.hInstance     = hInstance;
		 wndclass.hIcon         = NULL;
		 wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
		 wndclass.hbrBackground = (HBRUSH)(COLOR_BACKGROUND + 1);
		 wndclass.lpszMenuName  = NULL;
		 wndclass.lpszClassName = szAPP_NAME;
		 RegisterClass (&wndclass);         
		 }
	
	// Create the main window
	hAppWnd = CreateWindow (szAPP_NAME, szAPP_NAME, WS_OVERLAPPEDWINDOW,
	            CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
	            NULL, NULL, hInstance, NULL);
	BOOL bOK = (hAppWnd != NULL);
	if (bOK) {
		RegisterAppWindow(hAppWnd);
		ShowWindow (hAppWnd, nCmdShow);
		UpdateWindow (hAppWnd);
		}

	//	Initialize LookItUp
	if (bOK) {
		pLI = InitLookup();
		bOK = (pLI != NULL);
		}

	//	Get user-configurable settings
	nFontSize = GetPrivateProfileInt(szMISC, szFONT_SIZE, nDEFAULT_FONT_SIZE, szTESTIT_INI);
	GetPrivateProfileString(szMISC, szFONT_NAME, szARIAL, szFontName, STR_LEN(szFontName), szTESTIT_INI);
	
	return (bOK);
}



BOOL StopApp (INT nErrorCode)
{
	DEBUG_OUT(TL_VERBOSE, ("StopApp(%d)\n", nErrorCode));

	//	Clean up
    if (nErrorCode != 0) {
        DEBUG_OUT(TL_BASIC, ("stopping the application with error code %d", nErrorCode));
        STATIC BOOL bFirstTime = TRUE;
        if (bFirstTime) {
	    	InitAppShutdown();
	    	bFirstTime = FALSE;
	    	}
        }

    return (TRUE);
}



BOOL TermApp (VOID)
{
	DEBUG_OUT(TL_VERBOSE, ("TermApp()\n"));
	if (pLI) {
		EndLookup(pLI);
		pLI = NULL;
		}
	END_DEBUGGING();

    return (TRUE);
}


BOOL ParseCmdLine (PCSZ pszCmdLine)
{
	DEBUG_OUT(TL_VERBOSE, ("ParseCmdLine(%s)\n", pszCmdLine));
	BOOL bOK=TRUE;

    WinAssert(pszCmdLine);
    do {
        pszCmdLine = SkipSpaces(pszCmdLine);
        if (pszCmdLine[0]==cNULL) {
            break;
            }
        if ((pszCmdLine[0]!='-') && (pszCmdLine[0]!='/')) {
            bOK = FALSE;
            break;
            }
        pszCmdLine++;
        switch (pszCmdLine[0]) {
            case 'n' : case 'N':
                bDebugging = FALSE;
                pszCmdLine++;
                break;
            case 'p' : case 'P':
                pszCmdLine++;
            	ParseString(pszCmdLine, szPhrase, STR_LEN(szPhrase), &pszCmdLine);
            	break;
            default : {
                bOK = FALSE;
                }
            }
        } while (bOK);
    if (!bOK) {
        bOK = ReportError("Invalid command line!", szAPP_NAME);
        }

    return (bOK);
}



LONG FAR APIENTRY WndProc (HWND hwnd, UINT message, UINT wParam, LONG lParam)
{
	DEBUG_OUT(TL_GARRULOUS, ("WndProc(%x,%x,%x,%ld)\n", hwnd, message, wParam, lParam));

	switch (message) {

	case WM_PAINT: {
		PAINTSTRUCT ps;
		HDC hdc;
		hdc = BeginPaint(hwnd, &ps);
		UpdateDisplay(hwnd, hdc);
		EndPaint(hwnd, &ps);
		return (0);
		}
	               
	case WM_CLOSE: {
		StopApp(0);
		DestroyWindow(hAppWnd);
		return (0);
		}

	case WM_LBUTTONDBLCLK: {
		// BOOL DLLEXPORT LookupPhrase (PLOOKUP_INFO pLI, PCSZ pszPhrase, PCSZ pszSource, LOOKUP_TYPE eType);
		LOOKUP_TYPE eType = IsControlKeyPressed(TRUE) ? eCROSS_REFS : eDEFINITION;
		BOOL bOK = IsShiftKeyPressed(TRUE)
			? LookupPhrase(pLI, szPhrase, "THES1", eSYNONYMS)
			: LookupPhrase(pLI, szPhrase, "DICT4", eType);
		if (bOK) {
			pszResult = pLI->pszText;
			nResultLen = StringLength(pLI->pszText);
			}
		else {
			CONST CHAR szERROR[] = "stupid error!";
			pszResult = szERROR;
			nResultLen = STR_LEN(szERROR);
			}
		InvalidateRect(hwnd, NULL, TRUE);
		break;
		}

	case WM_DESTROY: {
		PostQuitMessage(0);
		hAppWnd = NULL;
		return (0);
		}

	default:
		break;
		}
	               
	return (DefWindowProc(hwnd, message, wParam, lParam));
}


BOOL UpdateDisplay (HWND hwnd, HDC hdc)
{
	DEBUG_OUT(TL_VERBOSE, ("UpdateDisplay(%x, %x)\n", hwnd, hdc));

    PLOGFONT plogfont = ALLOC(LOGFONT);
    lstrcpy(plogfont->lfFaceName, "Arial");
    plogfont->lfHeight = -2 * nFontSize;
    plogfont->lfWeight = FW_BOLD;

    HFONT hNewFont;
    HFONT hOldFont;
    hNewFont = CreateFontIndirect(plogfont);
    SetBkMode(hdc, TRANSPARENT);               
    SetTextColor(hdc, WHITE);
    hOldFont = SelectObject(hdc, hNewFont);

    RECT rect;
    GetClientRect (hwnd, &rect);
    DrawText (hdc, pszResult, nResultLen, &rect, DT_WORDBREAK);
    SelectObject(hdc, hOldFont);
    DeleteObject(hNewFont);
    FREE(plogfont);
    
    return (TRUE);
}
