//	Copyleft 1993-1996 Tom O'Hara		TrlLookup source
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

#if !defined(_TRL_LOOKUP_H)
#define _TRL_LOOKUP_H

#if TRUE
#include "CommonLookup.h"
#endif

#if !defined(SKIP_LOOKUP_DETAILS)
#include "TrlPhrase.h"
#include "TrlIndexInfo.h"
#endif

#if !defined(DLL_EXPORT)
#define DLL_EXPORT			__declspec(dllexport)
#endif

#if defined(__cplusplus)
extern "C" {
#endif

//  Constants
//
CONST CHAR szLOOKUP[] =         "TrlLookup";
CONST CHAR szLOOKUP_INI[] =     "TrlLookup.INI";
CONST CHAR szLIB_NAME[] =       "TrlLookup";
CONST CHAR szSOURCE[] =         "SOURCE";
CONST CHAR szBNX_DIR[] =        "BnxDirectory";
CONST CHAR szDATA_DIR[] =       "DataDirectory";
CONST INT nMAX_SOURCES =        10;
CONST INT nKEY_MAX =            5;
CONST INT nLOOKUP_TEXT_MAX =    65535;

//  Type declarations
//

#if !defined(SKIP_LOOKUP_DETAILS)

typedef struct {
    CHAR szSource[10];
    CHAR szIndex[10];
    IDXFILE_INFO xi;
    PFILE hIdxFile;
    LONG lIdxSize;
    LONG lIdxStart;
    PFILE hDatFile;
    LONG lDatSize;
//  PPSTR apszLastPhrase;
    CHAR apszLastPhrase[nMAX_GROUPS][nKEY_MAX + 1];
    INT nNumGroups;
    } SRC_INFO, *PSRC_INFO, **PPSRC_INFO;

typedef struct {
    PSRC_INFO apSrc[nMAX_SOURCES];      // list of reference sources
    INT nNumSources;                    // count of reference sources
    PSZ pszText;                        // buffer for results
    INT nTextLen;                       // current length of result text
    CHAR szBnxDir[MAX_PATH];            // where index files reside
    CHAR szDataDir[MAX_PATH];           // where the actual data files reside
    } LOOKUP_INFO, *PLOOKUP_INFO;

#else

typedef struct {
    INT nDummy;
    } SRC_INFO, *PSRC_INFO, **PPSRC_INFO;

typedef struct {
    INT nDummy;
    } LOOKUP_INFO, *PLOOKUP_INFO;

#endif


#if !defined(SKIP_LOOKUP_DETAILS)

//  'Internal' API
//
PSRC_INFO DLL_EXPORT     OpenSource      (PCSZ pszSourceName, PCSZ pszBnxDir, PCSZ pszDataDir);
PSRC_INFO DLL_EXPORT     CloseSource     (PSRC_INFO pSrc);
PSRC_INFO DLL_EXPORT     GetSourceHandle (PPSRC_INFO ppSrc, INT nNumSources, PCSZ pszIndex);
BOOL DLL_EXPORT          DoLookupPhrase  (PSRC_INFO pSrc, PCSZ pszPhrase, PSZ pszBuffer, INT nBufferLen, LOOKUP_TYPE eType);
                   
#endif


//  Exported API
//	TODO: use Trl prefix
//
PLOOKUP_INFO DLL_EXPORT  OldInitLookup	(HINSTANCE hInst, HWND hWndFrame, PCSZ pszClientAppName);
PLOOKUP_INFO DLL_EXPORT  InitLookup      (HINSTANCE hInst, HWND hWndFrame, 
										 PCSZ pszClientAppName, PCSZ pszDataDir, PCSZ pszIndexDir);
BOOL DLL_EXPORT          EndLookup       (HINSTANCE hInst, PLOOKUP_INFO pLI);
BOOL DLL_EXPORT          AddSource       (PLOOKUP_INFO pLI, PCSZ pszSource);
BOOL DLL_EXPORT          LookupPhrase    (PLOOKUP_INFO pLI, PCSZ pszPhrase, PCSZ pszSource, LOOKUP_TYPE eType);
PCSZ DLL_EXPORT          GetResultsPtr   (PLOOKUP_INFO pLI);

#if defined(__cplusplus)
    }
#endif

#endif  // !defined(_TRL_LOOKUP_H)
