//	Copyleft 1993-1996 Tom O'Hara		TrlLookup source
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

#include "commonxx.h"
#include "TrlPhrase.h"

#if FALSE
INT PhraseCompare (PCSZ pszPhrase1, PCSZ pszPhrase2)
{
	INT nResult = 0; 
	Assert((pszPhrase1) && (pszPhrase2));
	do {
		while (IgnoreChar(*pszPhrase1)) {
			pszPhrase1++;
			}
		while (IgnoreChar(*pszPhrase2)) {
			pszPhrase2++;
			}
		nResult = ToUpper(*pszPhrase1) - ToUpper(*pszPhrase2);
		if (EndOfPhrase(pszPhrase1) || EndOfPhrase(pszPhrase2)) {
			break;
			}
		pszPhrase1++;
		pszPhrase2++;
		} while (nResult == 0);

	return (nResult);
}
#endif


//	ignore certain special characters and parenthesized subphrases
//
PCSZ SkipExtraneous (PCSZ pszPhrase, BOOL bStrict)
{
	BOOL bChecked;
	do {
		while (IgnoreChar(*pszPhrase, bStrict)) {
			pszPhrase++;
			}
		bChecked = TRUE;
		if (*pszPhrase == cLEFT_PAREN) {
			do {
				pszPhrase++;
				} while ((*pszPhrase) && (*pszPhrase != cRIGHT_PAREN));
			bChecked = FALSE;
			}
		} while ((*pszPhrase) && (!bChecked));
	
	return (pszPhrase);
}


INT GetKey (PSZ pszKey, INT nMaxChars, PCSZ pszPhrase, BOOL bStrict)
{
	INT nLen = 0;

	//	copy all of the important characters (eg, 'man-handle' to 'manhandle')
	//	
	do {
		pszPhrase = SkipExtraneous(pszPhrase, bStrict);
		pszKey[nLen++] = ToUpper(*pszPhrase);
		pszPhrase++;
		} while ((*pszPhrase) && (nLen <= nMaxChars));

	//	remove a trailing sense superscript (eg, 'yew{1}' to 'yew')
	//		note chemicals will get truncated ('Zn{2}SiO{4}' to 'Zn{2}SiO')
	INT nLast = nLen - 1;
	if ((nLen > 0) && (pszKey[nLen - 1] == cRIGHT_BRACE)) {
		do {
			--nLen;
			} while ((nLen > 0) && (pszKey[nLen - 1] != cLEFT_BRACE));
		}

	pszKey[nLen] = cNULL;

	return (nLen);
}


INT PhraseCompare (PCSZ pszPhrase1, PCSZ pszPhrase2, BOOL bStrict)
{
	CHAR szKey1[256];
	CHAR szKey2[256];
	
	GetKey(szKey1, MAX_CHARS(szKey1), pszPhrase1, bStrict);
	GetKey(szKey2, MAX_CHARS(szKey2), pszPhrase2, bStrict);

	return (StringCompare(szKey1, szKey2));
}
