//-----------------------------------------------------------------------------
//	Wrappers
//-----------------------------------------------------------------------------

//	Helper inlines
//
inline IsKeyPressed (int nKey, BOOL bAsync)
{
    return (bAsync ? GetAsyncKeyState(nKey) : GetKeyState(nKey));
}

inline IsShiftKeyPressed (BOOL bAsync)
{
    return (IsKeyPressed(VK_SHIFT, bAsync));
}

inline IsControlKeyPressed (BOOL bAsync)
{
    return (IsKeyPressed(VK_CONTROL, bAsync));
}

inline IsAltKeyPressed (BOOL bAsync)
{
    return (IsKeyPressed(VK_MENU, bAsync));
}

inline unsigned Abs (int nNum)
{
    return(nNum > 0 ? nNum : -nNum);
}

inline PCSZ SkipSpaces (PCSZ pszText)
{
    while (isspace(*pszText)) {
        pszText++;
        };
    return (pszText);
}

inline CHAR ToUpper (CHAR ch)
{
	return ((CHAR)toupper(ch));
}

inline PSZ StringCopy (PSZ pszSource, PCSZ pszDest)
{
	return (lstrcpy(pszSource, pszDest));
}

inline PSZ StringAppend (PSZ pszSource, PCSZ pszDest)
{
	return (lstrcat(pszSource, pszDest));
}

//inline INT min(INT n, INT m) { return ( (n < m) ? n : m ); }
//inline INT max(INT n, INT m) { return ( (n > m) ? n : m ); }
//inline LONG min(LONG n, LONG m) { return ( (n < m) ? n : m ); }
//inline LONG max(LONG n, LONG m) { return ( (n > m) ? n : m ); }

INLINE BOOL IsAppActive (VOID)			{ return (bAppActive); }
INLINE VOID SetAppActive (BOOL bActive)	{ bAppActive = bActive; }
INLINE HWND GetClientAppWnd (VOID)  	{ return (hClientAppWnd); }
INLINE VOID SetClientAppWnd (HWND hWnd) { hClientAppWnd = Wnd; }
INLINE PCSZ GetClientAppName (VOID)		{ return (szClientAppName); }
INLINE VOID SetClientAppName (PCSZ pszName) \
				{ ASSERT(pszName);
				  StringCopy(szClientAppName, pszName); }

inline VOID SetTraceLevel (INT nLevel)
{
#if defined(_DEBUG)
	nTraceLevel = nLevel;
#endif
}

