//	Copyleft 1993-1996 Tom O'Hara		Wordz source
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

// Options.h : header file
//

class CBookshelfOptions;
class CTrlOptions;
class CWordnetOptions;

CONST CHAR szDONT_ASK_TO_SAVE[] =	"DontAskToSave";
CONST CHAR szBORDERLESS_WINDOWS[] = "BorderlessWindows";
CONST CHAR szSAVE_LAYOUT[] =		"SaveLayout";
CONST CHAR szLOOKUP_DEFINITION[] =	"IncludeDefinitions";
CONST CHAR szLOOKUP_DESCENDANTS[] =	"IncludeDescendants";
CONST CHAR szLOOKUP_REFERENCES[] =	"IncludeReferences";
CONST CHAR szLOOKUP_SYNONYMS[] =	"IncludeSynonyms";
CONST CHAR szWINDOW_BACKGROUND[] =	"WindowBackground";
CONST CHAR szTEXT_COLOR[] =			"TextColor";
CONST CHAR szTEXT_BACKGROUND[]=		"TextBackground";

// TODO: place in common.h
CONST COLORREF clrLIGHT_GRAY = RGB(192, 192, 192);
CONST COLORREF clrGRAY = RGB(128, 128, 128);
//CONST COLORREF clrLIGHT_GRAY = RGB(192, 192, 192);
CONST COLORREF clrBLACK = RGB(0, 0, 0);
CONST COLORREF clrPALE_GREEN = RGB(159, 225, 196);
CONST COLORREF clrOFF_BLUE = RGB(166, 202, 240);

/////////////////////////////////////////////////////////////////////////////
// CWordzOptions dialog

class CWordzOptions : public CPropertyPage
{
	DECLARE_DYNCREATE(CWordzOptions)

// Construction
public:
	CWordzOptions();
	~CWordzOptions();

// Dialog Data
	//{{AFX_DATA(CWordzOptions)
	enum { IDD = IDD_PROPPAGE_WORDZ };
	BOOL	m_bDontAskToSave;
	BOOL	m_bBorderlessWindows;
	BOOL	m_bSaveLayout;
	BOOL	m_bIncludeDefinitions;
	BOOL	m_bIncludeDescendants;
	BOOL	m_bIncludeReferences;
	BOOL	m_bIncludeSynonyms;
	//}}AFX_DATA
	BOOL m_bSettingsChanged;

// Operations
	BOOL ApplySettings (VOID);
	VOID PrepareMisc (VOID);

// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CWordzOptions)
	public:
	virtual void OnOK();
	virtual BOOL OnApply();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CWordzOptions)
	afx_msg void OnActiveCell();
	afx_msg void OnClueBackground();
	afx_msg void OnClueText();
	afx_msg void OnGridBackground();
	afx_msg void OnGridBorder();
	afx_msg void OnGridText();
	afx_msg void OnTextBackground();
	afx_msg void OnTextColor();
	afx_msg void OnWindowBackground();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

/////////////////////////////////////////////////////////////////////////////
// CWordzOptionsDlg

class CWordzOptionsDlg : public CPropertySheet
{
	DECLARE_DYNAMIC(CWordzOptionsDlg)

// Construction
public:
	CWordzOptionsDlg(CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
	CWordzOptionsDlg(UINT nIDCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
	CWordzOptionsDlg(LPCTSTR pszCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
	VOID CWordzOptionsDlg::CommonInit (VOID);

// Attributes
public:
	enum { IDD = IDD_WORDZ_OPTIONS };
	BOOL m_bSettingsChanged;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWordzOptionsDlg)
	public:
	virtual int DoModal();
	//}}AFX_VIRTUAL

// Implementation
public:
	CWordzOptions m_pageWordzOptions;
	CBookshelfOptions m_pageBookshelfOptions;
	CTrlOptions m_pageTrlOptions;
	CWordNetOptions m_pageWordNetOptions;
	
public:
	virtual ~CWordzOptionsDlg();

	// Generated message map functions
protected:
	//{{AFX_MSG(CWordzOptionsDlg)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

