//	Copyleft 1993-1996 Tom O'Hara		Wordz source
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

// wordzfrm.cpp : implementation file
//

#include "stdafx.h"
#include "wordz.h"
#include "wordzfrm.h"

IMPLEMENT_DYNCREATE(CWordzFrame, CMDIChildWnd)

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif


/////////////////////////////////////////////////////////////////////////////
// CWordzFrame


CWordzFrame::CWordzFrame()
{
	DEBUG_OUT(TL_VERBOSE, ("CWordzFrame::CWordzFrame()\n"));
	EnableAutomation();
}

CWordzFrame::~CWordzFrame()
{
	DEBUG_OUT(TL_VERBOSE, ("CWordzFrame::~CWordzFrame()\n"));
}

void CWordzFrame::OnFinalRelease()
{
	DEBUG_OUT(TL_VERBOSE, ("CWordzFrame::OnFinalRelease()\n"));
	// When the last reference for an automation object is released
	//	OnFinalRelease is called.  This implementation deletes the 
	//	object.  Add additional cleanup required for your object before
	//	deleting it from memory.

	delete this;
}


//	Update the caption title for the MDI child frame. This just updates the
//	frame's parent as in the CMDIChildWnd implementation. But the window's title 
//	is left alone, so that the view can set it as it pleases.
//
void CWordzFrame::OnUpdateFrameTitle(BOOL bAddToTitle)
{
	DEBUG_OUT(TL_VERBOSE, ("OnUpdateFrameTitle(%d)\n", bAddToTitle));

	// update our parent window first
	GetMDIFrame()->OnUpdateFrameTitle(bAddToTitle);
}


BEGIN_MESSAGE_MAP(CWordzFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(CWordzFrame)
	ON_COMMAND(ID_VIEW_MAKERESIZABLE, OnViewMakeresizable)
	ON_UPDATE_COMMAND_UI(ID_VIEW_MAKERESIZABLE, OnUpdateViewMakeresizable)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CWordzFrame, CMDIChildWnd)
	//{{AFX_DISPATCH_MAP(CWordzFrame)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWordzFrame message handlers

BOOL CWordzFrame::PreCreateWindow(CREATESTRUCT& cs) 
{
	m_bNotResizable = GetAppOption("BorderlessWindows", FALSE);
	if (m_bNotResizable) {
		cs.style &= ~(WS_THICKFRAME | WS_CAPTION);
	}
	return CMDIChildWnd::PreCreateWindow(cs);
}


// Toggle the status of the frame's resize border. Normally the border is thin
// so that resizing is not possible.
//
// TODO: disable command if frame is maximized
//
void CWordzFrame::OnViewMakeresizable() 
{
	DEBUG_OUT(TL_VERBOSE, ("CWordzFrame::OnViewMakeresizable()\n"));

	// Determine the new style
	DWORD dwRemove = 0;
	DWORD dwAdd = 0;
	if (m_bNotResizable) {
		ASSERT((GetStyle() & WS_THICKFRAME) == 0x0);	// current setting should be off
		dwAdd = (WS_THICKFRAME | WS_CAPTION);
	}
	else {
		ASSERT((GetStyle() & WS_THICKFRAME) != 0x0);	// current setting should be on
		dwRemove = (WS_THICKFRAME | WS_CAPTION);
	}
	m_bNotResizable = !m_bNotResizable;		// toggle the setting

	// Add or remove the thick border for resizing the frame
	ModifyStyle(dwRemove, dwAdd);
#if FALSE
	InvalidateRect(NULL);
	UpdateWindow();
#else
	// Get the entire window rectangle (including frame)
	CRect rect;
	GetWindowRect(rect);
	DUMP_RECT(TL_VERBOSE, "wordz frame window rect: ", rect, "\n");
	GetParent()->ScreenToClient(rect);
	//GetClientRect(rect);
	//MapWindowPoints(GetParent(), rect);

	// Force the window to be repainted so that the new border takes effect
	// TODO: figure out a standard way to do this (rather than this cheesy technique)
	rect.InflateRect(1, 1);
	DUMP_RECT(TL_VERBOSE, "moving wordz frame to ", rect, "\n");
	MoveWindow(rect, FALSE);
	rect.InflateRect(-1, -1);
	DUMP_RECT(TL_VERBOSE, "moving wordz frame to ", rect, "\n");
	MoveWindow(rect, TRUE);
#endif
}


void CWordzFrame::OnUpdateViewMakeresizable(CCmdUI* pCmdUI) 
{
	DEBUG_OUT(TL_GARRULOUS + 1, ("CWordzFrame::OnUpdateViewMakeresizable()\n"));
    pCmdUI->SetCheck(m_bNotResizable == FALSE);
}
