//	Copyleft 1993-1996 Tom O'Hara		CWord source
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

//  about.cpp: class implementation for About dialog
//

#include "stdafx.h"
#include "resource.h"
#include "about.h"

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

CONST CHAR szINVALID_GNUGPL_DLL[] =  "Warning: Missing or invalid DLL (%s).\n";
CONST CHAR szGNUGPL[] = "GnuGPL.dll";

// void DoGnuLicenseDialog (HWND hWnd); // in GnuGPL.dll
typedef VOID (*PFN_DoGnuLicenseDialog) (HWND hWnd);
DEFINE_LIBRARY(GnuGPL);
DEFINE_FUNCTION(DoGnuLicenseDialog);

CAboutDlg::CAboutDlg(CWnd* pParent /* = NULL */) 
	: CDialog(CAboutDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
	ResolveGnuGplReferences();
}

CAboutDlg::~CAboutDlg(VOID)
{
	ReleaseGnuGplReferences();
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_BN_CLICKED(IDC_VIEW_LICENSE, OnViewLicense)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL CAboutDlg::ResolveGnuGplReferences (VOID)
{
	BOOL bOK = FALSE;

	while (!bOK) {
		try {
			LOAD_LIBRARY(GnuGPL);
			LOAD_FUNCTION(GnuGPL, DoGnuLicenseDialog);
			bOK = TRUE;
			}
		catch (...) {
			DEBUG_OUT(TL_ERROR, ("Trouble loading GnuGPL!\n"));
			}
		if (!bOK) {
			UNLOAD_LIBRARY(GnuGPL);
			INT nResponse = ReportAppErrorFmt(szINVALID_GNUGPL_DLL, szGNUGPL);
			if (nResponse == IDIGNORE) {
				break;
				}
			}
		}

	return (bOK);
}


BOOL CAboutDlg::ReleaseGnuGplReferences (VOID)
{
	UNLOAD_LIBRARY(GnuGPL);

	return (TRUE);
}


void CAboutDlg::OnViewLicense() 
{
	if (pDoGnuLicenseDialog) {
		pDoGnuLicenseDialog(this->m_hWnd);
		}
}
