//	Copyleft 1993-1996 Tom O'Hara		CWord source
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

// mainfrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
//#include "common.h"
#include "cword.h"
#include "Lookup.h"
#include "Options.h"
#include "mainfrm.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

#define new DEBUG_NEW

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
    //{{AFX_MSG_MAP(CMainFrame)
    ON_WM_CREATE()
	ON_COMMAND(ID_OPTIONS, OnOptions)
	ON_COMMAND(ID_FILE_PUNT, OnFilePunt)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// arrays of IDs used to initialize control bars

// toolbar buttons - IDs are command buttons
static UINT BASED_CODE buttons[] =
{
    // same order as in the bitmap 'toolbar.bmp'
    ID_FILE_NEW,
    ID_FILE_OPEN,
    ID_FILE_SAVE,
        ID_SEPARATOR,
    ID_EDIT_CUT,
    ID_EDIT_COPY,
    ID_EDIT_PASTE,
        ID_SEPARATOR,
    ID_FILE_PRINT,
    ID_APP_ABOUT,
};

static UINT BASED_CODE indicators[] =
{
    ID_SEPARATOR,           // status line indicator
    ID_INDICATOR_CAPS,
    ID_INDICATOR_NUM,
    ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
    // TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
    if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
        return -1;

    if (!m_wndToolBar.Create(this) ||
        !m_wndToolBar.LoadBitmap(IDR_MAINFRAME) ||
        !m_wndToolBar.SetButtons(buttons,
          sizeof(buttons)/sizeof(UINT)))
    {
        DEBUG_OUT(TL_BASIC, ("Failed to create toolbar\n"));
        return -1;      // fail to create
    }

    if (!m_wndStatusBar.Create(this) ||
        !m_wndStatusBar.SetIndicators(indicators,
          sizeof(indicators)/sizeof(UINT)))
    {
        DEBUG_OUT(TL_BASIC, ("Failed to create status bar\n"));
        return -1;      // fail to create
    }

	// Cheesy way to disable the status dialog
	// TODO: base this opon user preference
	PostMessage(WM_COMMAND, ID_VIEW_STATUS_BAR);
	PostMessage(WM_COMMAND, ID_VIEW_TOOLBAR);

    return 0;
}


/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
    CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
    CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::OnOptions() 
{
    DEBUG_OUT(TL_VERBOSE, ("CMainFrame::OnOptions\n"));

	CCWordOptionsDlg dlgOptions(this);
	dlgOptions.DoModal();
	if (dlgOptions.m_bSettingsChanged) {
		UpdateView();
		}
}


VOID CMainFrame::UpdateView (VOID)
{
    DEBUG_OUT(TL_VERBOSE, ("CMainFrame::UpdateView()\n"));

	// Get the template object so we can iterate the documents
	POSITION posTemplate = AfxGetApp()->GetFirstDocTemplatePosition();
	ASSERT(posTemplate != NULL);
	CDocTemplate* pTemplate = AfxGetApp()->GetNextDocTemplate(posTemplate);
	ASSERT(pTemplate);
	ASSERT(posTemplate == NULL);	// should have only one template

	// Iterate through the documents and update their views
	POSITION posDocument = pTemplate->GetFirstDocPosition();
	ASSERT(posDocument);
	CDocument* pDoc = pTemplate->GetNextDoc(posDocument);
	pDoc->UpdateAllViews(NULL,					// view that modified the doc
						 lHINT_OPTION_CHANGE);  // update hint
	ASSERT(posDocument == NULL);	// should have only one document
}


// OnFilePunt: Quit the application Now!
//
// TODO: the application class handle this
//
void CMainFrame::OnFilePunt() 
{
    DEBUG_OUT(TL_VERBOSE, ("CMainFrame::OnFilePunt()\n"));

	DestroyWindow();
	AfxOleTerm();
	ExitProcess(666);
}
