rem @echo off
REM Batch file for producing source file tar archive

REM Get a list of all the source files
dir /b /-p /s *.cpp *.c *.cxx *.h *.inl makefile *.mak *.rc* *.def *.ico *.bmp *.cur *.bat *.str *.hxx *.asm *.inc *.ver *.odl *.rul setup.lst ReadMe.txt > source_files0.lst

REM Filter out stuff not to be distriubted
egrep -i -v "(\\BACKUP\\)|(\\INFO\\)|(\\RCS\\)|(\\TEST\\)|(\\OLD\\)|(\\FUBAR\\)|(\\JUNK\\)"  < source_files0.lst > source_files1.lst

REM Convert into Unix-style pathnames for gtar
REM Also make the pathname relative
perl -p -e "s/\\/\//g; s/D:\/cword/./ig;" < source_files1.lst > source_files2.lst
copy source_files2.lst source_files.lst

REM Tar the files
REM if exist source_files.tar call dobackup source_files.tar
gtar cfvT source_files.tar source_files.lst

REM Compress and rename the tar listing
gzip source_files.tar
if exist source_files.tgz del source_files.tgz
move source_files.tar.gz source_files.tgz
