//	Copyleft 1993-1996 Tom O'Hara		CWord source
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

// Options.h : header file
//


// Type definition (forward references)
//
class CBookshelfOptions;
class CTrlOptions;
class CWordNetOptions;


// Constants
//
CONST CHAR szGRID_TEXT[] =			"GridText";
CONST CHAR szGRID_INDEX_TEXT[] =	"GridIndexText";
CONST CHAR szGRID_BORDER[] =		"GridBorder";
CONST CHAR szCLUE_BACKGROUND[] =	"ClueBackground";
CONST CHAR szGRID_BACKGROUND[] =	"GridBackground";
CONST CHAR szCLUE_TEXT[] =			"ClueText";
CONST CHAR szACTIVE_CELL[] =		"ActiveCell";
CONST CHAR szBLACKENED_CELL[] = 	"BlackenedCell";
CONST CHAR szSCALE_FACTOR[] =		"GridScaleFactor";

CONST COLORREF clrLIGHT_GRAY = RGB(192, 192, 192);
CONST COLORREF clrGRAY = RGB(128, 128, 128);
//CONST COLORREF clrLIGHT_GRAY = RGB(192, 192, 192);
CONST COLORREF clrBLACK = RGB(0, 0, 0);
CONST COLORREF clrPALE_GREEN = RGB(159, 225, 196);
CONST COLORREF clrOFF_BLUE = RGB(166, 202, 240);


/////////////////////////////////////////////////////////////////////////////
// CCwordOptions dialog

class CCwordOptions : public CPropertyPage
{
	DECLARE_DYNCREATE(CCwordOptions)

// Construction
public:
	CCwordOptions();
	~CCwordOptions();

// Dialog Data
	//{{AFX_DATA(CCwordOptions)
	enum { IDD = IDD_PROPPAGE_CWORD };
	CButton	m_btnDarkCell;
	CButton	m_btnGridText;
	CButton	m_btnGridBorder;
	CButton	m_btnClueBackground;
	CButton	m_btnGridBackground;
	CButton	m_btnClueText;
	CButton	m_btnActiveCell;
	CString	m_sScaleFactor;
	//}}AFX_DATA
	BOOL m_bSettingsChanged;
	COLORREF m_colorGridText;
	COLORREF m_colorIndexText;
	COLORREF m_colorGridBorder;
	COLORREF m_colorClueBackground;
	COLORREF m_colorGridBackground;
	COLORREF m_colorClueText;
	COLORREF m_colorActiveCell;
	COLORREF m_colorBlackenedCell;
	INT m_nScaleFactor;

// Operations
	BOOL ApplySettings (VOID);
	VOID HandleColorOption (COLORREF& clrCurrent);

// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CCwordOptions)
	public:
	virtual void OnOK();
	virtual BOOL OnApply();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CCwordOptions)
	afx_msg void OnActiveCell();
	afx_msg void OnClueBackground();
	afx_msg void OnClueText();
	afx_msg void OnGridBackground();
	afx_msg void OnGridBorder();
	afx_msg void OnGridText();
	afx_msg void OnDarkCell();
	afx_msg void OnEditchangeScaleFactor();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

/////////////////////////////////////////////////////////////////////////////
// CCWordOptionsDlg

class CCWordOptionsDlg : public CPropertySheet
{
	DECLARE_DYNAMIC(CCWordOptionsDlg)

// Construction
public:
	CCWordOptionsDlg(CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
	CCWordOptionsDlg(UINT nIDCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
	CCWordOptionsDlg(LPCTSTR pszCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
	VOID CCWordOptionsDlg::CommonInit (VOID);

// Attributes
public:
	enum { IDD = IDD_CWORD_OPTIONS };
	BOOL m_bSettingsChanged;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCWordOptionsDlg)
	public:
	virtual int DoModal();
	//}}AFX_VIRTUAL

// Implementation
public:
	CCwordOptions m_pageCWordOptions;
	CBookshelfOptions m_pageBookshelfOptions;
	CTrlOptions m_pageTrlOptions;
	CWordNetOptions m_pageWordNetOptions;
	
public:
	virtual ~CCWordOptionsDlg();

	// Generated message map functions
protected:
	//{{AFX_MSG(CCWordOptionsDlg)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

